var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var GameEngine = (function (_super) {
            __extends(GameEngine, _super);
            function GameEngine() {
                _super.call(this, 960, 720, Phaser.AUTO, 'MainContent', '', true);
                this.state.add('Boot', Client.BootState, false);
                this.state.add('Preloader', Client.PreloaderState, false);
                this.state.add('MainMenu', Client.MainState, false);
                this.preserveDrawingBuffer = true;
                this.state.start('Boot');
            }
            return GameEngine;
        }(Phaser.Game));
        Client.GameEngine = GameEngine;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
window.onload = function () {
    new DressGame.Client.GameEngine();
};
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        "use strict";
        var AniGirl = (function (_super) {
            __extends(AniGirl, _super);
            function AniGirl(game, x, y, id) {
                _super.call(this, game);
                this.id = id;
                this.x = x;
                this.y = y;
                this.back = this.game.add.image(0, 0, "stage1", "back" + (this.id + 1).toString() + ".png");
                this.add(this.back);
                this.eyes = this.game.add.image(0, 0, "stage1", "eyes" + (this.id + 1).toString() + ".png");
                this.add(this.eyes);
                this.over = this.game.add.image(0, 0, "stage1", "girl" + (this.id + 1).toString() + ".png");
                this.add(this.over);
            }
            AniGirl.prototype.init = function () {
                this.game.tweens.removeFrom(this.eyes);
                this.game.tweens.removeFrom(this.back);
                this.game.tweens.removeFrom(this.over);
                this.back.x = this.eyes.x = this.over.x = 0;
                this.back.y = this.eyes.y = this.over.y = 0;
            };
            AniGirl.prototype.start = function () {
                switch (this.id) {
                    case 0:
                        this.game.add.tween(this.eyes).to({ x: 5 }, 1000, Phaser.Easing.Linear.None, true);
                        break;
                    case 1:
                        this.game.add.tween(this.eyes).to({ x: -3 }, 1000, Phaser.Easing.Linear.None, true);
                        break;
                }
            };
            return AniGirl;
        }(Phaser.Group));
        Client.AniGirl = AniGirl;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var BaseButton = (function (_super) {
            __extends(BaseButton, _super);
            function BaseButton(game, x, y) {
                _super.call(this, game, x, y);
            }
            return BaseButton;
        }(Phaser.Sprite));
        Client.BaseButton = BaseButton;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Carousel = (function (_super) {
            __extends(Carousel, _super);
            function Carousel(game, id, idCase) {
                _super.call(this, game);
                this.onSignal = new Phaser.Signal();
                this.glow = new Client.GlowFilter(this.game, 0.05);
                this.inCase = idCase;
                this.type = id;
                this.imagesBack = [];
                this.imagesFront = [];
                this.imagesGlow = [];
                var tmpImage;
                var bmd;
                var back = Client.GameConfig.CAROUSELS[this.type]["backimages"];
                if (back)
                    for (var i = 0; i < back.length; i++) {
                        if (back[i]) {
                            this.imagesBack[i] = new Phaser.Image(this.game, 0, 0, Client.GameConfig.CAROUSELS[this.type]["atlas"], back[i]);
                            this.add(this.imagesBack[i]);
                            this.imagesBack[i].anchor.setTo(0.5, 0.5);
                            if (Client.GameConfig.CAROUSELS[this.type]["glow"] == "back") {
                                this.imagesBack[i].name = back[i];
                                this.imagesBack[i].inputEnabled = true;
                                this.imagesBack[i].input.useHandCursor = true;
                                this.imagesBack[i].input.pixelPerfectClick = this.imagesBack[i].input.pixelPerfectOver = true;
                                this.imagesBack[i].input.pixelPerfectAlpha = 0;
                                this.imagesBack[i].events.onInputDown.add(this.onClick, this);
                                this.imagesBack[i].events.onInputOver.add(this.onScaleOver, this);
                                this.imagesBack[i].events.onInputOut.add(this.onScaleOut, this);
                            }
                        }
                    }
                if (Client.GameConfig.CAROUSELS[this.type]["middleimage"]) {
                    this.middleImage = new Phaser.Image(this.game, 0, 0, Client.GameConfig.CAROUSELS[this.type]["atlas"], Client.GameConfig.CAROUSELS[this.type]["middleimage"]);
                    if (Client.GameConfig.CAROUSELS[this.type]["glow"] == "middle") {
                        tmpImage = new Phaser.Image(this.game, 0, 0, Client.GameConfig.CAROUSELS[this.type]["atlas"], Client.GameConfig.CAROUSELS[this.type]["middleimage"]);
                        bmd = this.game.make.bitmapData();
                        bmd.load(tmpImage);
                        bmd.processPixelRGB(Client.Utils.paintWhite, this);
                        this.middleGlow = new Phaser.Image(this.game, 0, 0, bmd);
                        this.middleGlow.filters = [this.glow];
                        this.middleGlow.anchor.setTo(0.5, 0.5);
                        this.add(this.middleGlow);
                        this.middleGlow.visible = false;
                    }
                    this.add(this.middleImage);
                    this.middleImage.anchor.setTo(0.5, 0.5);
                    this.middleImage.inputEnabled = true;
                    this.middleImage.input.useHandCursor = true;
                    this.middleImage.input.pixelPerfectClick = this.middleImage.input.pixelPerfectOver = true;
                    this.middleImage.input.pixelPerfectAlpha = 0;
                    this.middleImage.events.onInputDown.add(this.onClick, this);
                    this.middleImage.events.onInputOver.add(this.onScaleOver, this);
                    this.middleImage.events.onInputOut.add(this.onScaleOut, this);
                }
                var front = Client.GameConfig.CAROUSELS[this.type]["frontimages"];
                for (var i = 0; i < front.length; i++) {
                    this.imagesFront[i] = new Phaser.Image(this.game, 0, 0, Client.GameConfig.CAROUSELS[this.type]["atlas"], front[i]);
                    this.add(this.imagesFront[i]);
                    this.imagesFront[i].anchor.setTo(0.5, 0.5);
                }
                if (Client.GameConfig.CAROUSELS[this.type]["overimage"]) {
                    this.overImage = new Phaser.Image(this.game, 0, 0, Client.GameConfig.CAROUSELS[this.type]["atlas"], Client.GameConfig.CAROUSELS[this.type]["overimage"]);
                    this.add(this.overImage);
                    this.overImage.anchor.setTo(0.5, 0.5);
                }
            }
            Carousel.prototype.onClick = function () {
                this.onSignal.dispatch({ type: this.inCase, id: this.type });
            };
            Carousel.prototype.onScaleOver = function (target) {
                switch (Client.GameConfig.CAROUSELS[this.type]["glow"]) {
                    case "back":
                        if (!this.imagesGlow[this.view]) {
                            var tmpImage = new Phaser.Image(this.game, 0, 0, Client.GameConfig.CAROUSELS[this.type]["atlas"], target.name);
                            var bmd = this.game.make.bitmapData();
                            bmd.load(tmpImage);
                            bmd.processPixelRGB(Client.Utils.paintWhite, this);
                            this.imagesGlow[this.view] = new Phaser.Image(this.game, 0, 0, bmd);
                            this.imagesGlow[this.view].filters = [this.glow];
                            this.imagesGlow[this.view].anchor.setTo(0.5, 0.5);
                            this.add(this.imagesGlow[this.view]);
                            this.setChildIndex(this.imagesGlow[this.view], 0);
                        }
                        this.imagesGlow[this.view].visible = true;
                        break;
                    case "middle":
                        this.middleGlow.visible = true;
                        break;
                }
            };
            Carousel.prototype.onScaleOut = function (target) {
                switch (Client.GameConfig.CAROUSELS[this.type]["glow"]) {
                    case "back":
                        for (var i = 0; i < this.imagesGlow.length; i++)
                            if (this.imagesGlow[i])
                                this.imagesGlow[i].visible = false;
                        break;
                    case "middle":
                        this.middleGlow.visible = false;
                        break;
                }
            };
            Carousel.prototype.setView = function (id) {
                this.view = id + Client.GameConfig.CAROUSELS[this.type]["offset"];
                if (this.view >= this.imagesBack.length && this.view >= this.imagesFront.length)
                    this.view = Client.GameConfig.CAROUSELS[this.type]["offset"];
                this.hideAll();
                if (this.imagesBack[this.view])
                    this.imagesBack[this.view].visible = true;
                if (this.imagesFront[this.view])
                    this.imagesFront[this.view].visible = true;
            };
            Carousel.prototype.hideAll = function () {
                for (var i = 0; i < this.imagesBack.length; i++) {
                    if (this.imagesBack[i])
                        this.imagesBack[i].visible = false;
                }
                for (var i = 0; i < this.imagesFront.length; i++) {
                    if (this.imagesFront[i])
                        this.imagesFront[i].visible = false;
                }
            };
            Carousel.prototype.hide = function () {
                this.visible = false;
            };
            return Carousel;
        }(Phaser.Group));
        Client.Carousel = Carousel;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Cloud = (function (_super) {
            __extends(Cloud, _super);
            function Cloud(game, id) {
                _super.call(this, game);
                this.type = id;
                this.cloudGroup = new Phaser.Group(this.game);
                this.add(this.cloudGroup);
                this.cloudImage = new Phaser.Image(this.game, 0, 0, 'stage1', 'cloud' + (this.type + 1).toString() + '.png');
                this.cloudGroup.add(this.cloudImage);
                switch (this.type) {
                    case 0:
                        this.cloudImage.anchor.setTo(0.5, 1);
                        break;
                    case 1:
                        this.cloudImage.anchor.setTo(0.5, 0);
                        break;
                }
                this.visible = false;
            }
            Cloud.prototype.show = function (imageAtlas, imageName, first) {
                if (this.textImage)
                    this.cloudGroup.removeChild(this.textImage);
                this.textImage = new Phaser.Image(this.game, 0, 0, imageAtlas, imageName);
                this.cloudGroup.add(this.textImage);
                switch (this.type) {
                    case 0:
                        this.textImage.y = -this.cloudImage.height / 2;
                        break;
                    case 1:
                        this.textImage.y = this.cloudImage.height / 2;
                        break;
                }
                this.textImage.anchor.setTo(0.5, 0.5);
                var me = this;
                if (first) {
                    this.cloudGroup.scale.x = 0.5;
                    this.cloudGroup.scale.y = 0.1;
                    this.textImage.visible = false;
                    this.visible = true;
                    var _cloudTween = this.game.add.tween(this.cloudGroup.scale).to({ x: 1, y: 1 }, 2000, Phaser.Easing.Quadratic.Out, true);
                    _cloudTween.onComplete.add(function () {
                        me.textImage.visible = true;
                        me.textImage.scale.x = me.textImage.scale.y = 0.2;
                        var _textTween = this.game.add.tween(me.textImage.scale).to({ x: 1, y: 1 }, 800, Phaser.Easing.Linear.None, true);
                        var _text1 = this.game.add.tween(me.textImage).to({ angle: -3 }, 300, Phaser.Easing.Linear.None, true, 600);
                        var _text2 = this.game.add.tween(me.textImage).to({ angle: 3 }, 600, Phaser.Easing.Linear.None, false);
                        var _text3 = this.game.add.tween(me.textImage).to({ angle: 0 }, 300, Phaser.Easing.Linear.None, false);
                        _text1.chain(_text2);
                        _text2.chain(_text3);
                    }, this);
                }
                else {
                    me.textImage.visible = true;
                    me.textImage.scale.x = me.textImage.scale.y = 0.2;
                    var _textTween = this.game.add.tween(me.textImage.scale).to({ x: 1, y: 1 }, 800, Phaser.Easing.Linear.None, true);
                    var _text1 = this.game.add.tween(me.textImage).to({ angle: -3 }, 300, Phaser.Easing.Linear.None, true, 600);
                    var _text2 = this.game.add.tween(me.textImage).to({ angle: 3 }, 600, Phaser.Easing.Linear.None, false);
                    var _text3 = this.game.add.tween(me.textImage).to({ angle: 0 }, 300, Phaser.Easing.Linear.None, false);
                    _text1.chain(_text2);
                    _text2.chain(_text3);
                }
            };
            Cloud.prototype.hide = function (forced) {
                if (forced === void 0) { forced = false; }
                var me = this;
                if (forced)
                    this.visible = false;
                else {
                    var _cloudTween = this.game.add.tween(this.cloudGroup.scale).to({ x: 0.1, y: 0.1 }, 1000, Phaser.Easing.Quadratic.Out, true);
                    _cloudTween.onComplete.add(function () {
                        me.visible = false;
                    }, this);
                }
            };
            return Cloud;
        }(Phaser.Group));
        Client.Cloud = Cloud;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Doll = (function (_super) {
            __extends(Doll, _super);
            function Doll(game, id) {
                _super.call(this, game);
                this.key = id;
                this.game = game;
                this.onSignal = new Phaser.Signal();
                this.glowGroup = new Phaser.Group(this.game);
                this.add(this.glowGroup);
                this.glow = new Client.GlowFilter(this.game, 0.25);
                this.images = [];
                for (var prop in Client.GameConfig.DOLLS[this.key]["images"]) {
                    if (!Client.GameConfig.DOLLS[this.key]["images"].hasOwnProperty(prop))
                        continue;
                    this.images[prop] = game.add.image(0, 0, Client.GameConfig.DOLLS[this.key]["atlas"], Client.GameConfig.DOLLS[this.key]["images"][prop]);
                    this.add(this.images[prop]);
                    if (prop === "body") {
                        this.images[prop].inputEnabled = true;
                        this.images[prop].input.pixelPerfectClick = this.images[prop].input.pixelPerfectOver = true;
                        this.images[prop].input.pixelPerfectAlpha = 20;
                        this.images[prop].events.onInputOver.add(this.onScaleOver, this);
                        this.images[prop].events.onInputOut.add(this.onScaleOut, this);
                        this.images[prop].events.onInputDown.add(this.onClick, this);
                        this.images[prop].input.useHandCursor = true;
                        if (Client.GameConfig.DOLLS[this.key]["eyes"] != null) {
                            this.eyes = new Client.Eyes(game, Client.GameConfig.DOLLS[this.key]["eyes"]["atlas"], Client.GameConfig.DOLLS[this.key]["eyes"]["id"]);
                            this.eyes.anchor.setTo(0.5, 0.5);
                            this.add(this.eyes);
                        }
                    }
                }
                this.glowGroup.filters = [this.glow];
                this.glowGroup.visible = false;
            }
            Doll.prototype.hide = function () {
                for (var prop in this.images) {
                    this.images[prop].visible = false;
                }
            };
            Doll.prototype.setView = function () {
                var i, j, items;
                this.hide();
                this.images["body"].visible = true;
                for (i = 0; i < Client.Globals.DOLLS_VIEW[this.key].length; i++) {
                    if (Client.GameConfig.DOLLS[this.key]["sets"][i][Client.Globals.DOLLS_VIEW[this.key][i]] != null) {
                        items = Client.GameConfig.DOLLS[this.key]["items"][Client.GameConfig.DOLLS[this.key]["sets"][i][Client.Globals.DOLLS_VIEW[this.key][i]]];
                        for (j = 0; j < items.length; j++) {
                            this.images[items[j]].visible = true;
                        }
                    }
                }
                if (this.images["shadow"])
                    this.images["shadow"].visible = this.isShadow;
                this.visible = true;
            };
            Doll.prototype.setActive = function (status) {
                this.isActive = status;
                this.images["body"].input.useHandCursor = this.isActive;
                if (!status)
                    this.glowGroup.visible = false;
            };
            Doll.prototype.showShadow = function (status) {
                this.images["shadow"].visible = status;
                this.isShadow = status;
            };
            Doll.prototype.play = function () {
                if (this.eyes)
                    this.eyes.startBlink();
            };
            Doll.prototype.stop = function () {
                if (this.eyes)
                    this.eyes.stopBlink();
            };
            Doll.prototype.onClick = function (target) {
                if (this.isActive)
                    this.onSignal.dispatch({ id: this.key });
            };
            Doll.prototype.onScaleOut = function (target) {
                if (this.isActive) {
                    this.scale.x = this.scale.y = 1;
                    this.glowGroup.visible = false;
                }
            };
            Doll.prototype.onScaleOver = function (target) {
                if (this.isActive) {
                    this.scale.x = this.scale.y = 1.05;
                    this.glowGroup.visible = true;
                }
            };
            Doll.prototype.update = function () {
            };
            return Doll;
        }(Phaser.Group));
        Client.Doll = Doll;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var DressCase = (function (_super) {
            __extends(DressCase, _super);
            function DressCase(game) {
                _super.call(this, game);
                this.veshalki = [];
                this.carousels = [];
                this.page = 0;
                this.onSignal = new Phaser.Signal();
                this.mainFrame = game.add.group();
                this.buttonsFrame = game.add.group();
                this.glow = new Client.GlowFilter(this.game, 0.05);
                this.backgrounds = [];
                for (var i = 0; i < 6; i++) {
                    this.backgrounds[i] = game.add.image(0, 0, 'stage2', "inside" + (i + 1).toString() + ".png");
                    this.add(this.backgrounds[i]);
                    this.backgrounds[i].visible = false;
                }
                this.arrowLeft = new Client.GlowObject(this.game, 578, 556, "stage2", "arrow_left.png", this.onArrowLeft, this);
                this.buttonsFrame.add(this.arrowLeft);
                this.arrowRight = new Client.GlowObject(this.game, 786, 576, "stage2", "arrow_right.png", this.onArrowRight, this);
                this.buttonsFrame.add(this.arrowRight);
                this.arrowLeft.scaleOver = this.arrowRight.scaleOver = 1.02;
                this.buttonsFrame.visible = false;
            }
            DressCase.prototype.setView = function (id, _page) {
                if (_page === void 0) { _page = 0; }
                this.id = id;
                this.page = _page;
                this.add(this.mainFrame);
                this.add(this.buttonsFrame);
                for (var prop in this.itemImages) {
                    this.itemImages[prop].input.destroy();
                    this.itemImages[prop].destroy();
                }
                for (var prop in this.itemBacks)
                    this.itemBacks[prop].destroy();
                for (var prop in this.itemGroups)
                    this.itemGroups[prop].destroy();
                if (this.carousels) {
                    for (var i = 0; i < this.carousels.length; i++) {
                        this.carousels[i].onSignal.removeAll();
                        this.carousels[i].destroy();
                    }
                }
                this.itemGroups = [];
                this.itemImages = [];
                this.itemBacks = [];
                this.glow = new Client.GlowFilter(this.game, 0.05);
                for (var prop in Client.GameConfig.DRESSING_CONFIG[this.id]["items"]) {
                    this.itemGroups[prop] = new Phaser.Group(this.game);
                    this.mainFrame.add(this.itemGroups[prop]);
                    this.itemImages[prop] = new Phaser.Image(this.game, 0, 0, Client.GameConfig.DRESSING_CONFIG[this.id]["atlas"], Client.GameConfig.DRESSING_CONFIG[this.id]["items"][prop]["image"]);
                    this.itemGroups[prop].x = Client.GameConfig.DRESSING_CONFIG[this.id]["items"][prop]["x"];
                    this.itemGroups[prop].y = Client.GameConfig.DRESSING_CONFIG[this.id]["items"][prop]["y"];
                    this.itemImages[prop].anchor.setTo(Client.GameConfig.DRESSING_CONFIG[this.id]["items"][prop]["anchor"][0], Client.GameConfig.DRESSING_CONFIG[this.id]["items"][prop]["anchor"][1]);
                    this.itemImages[prop].scale.setTo(Client.GameConfig.DRESSING_CONFIG[this.id]["items"][prop]["scale"], Client.GameConfig.DRESSING_CONFIG[this.id]["items"][prop]["scale"]);
                    if (Client.GameConfig.DRESSING_CONFIG[this.id]["items"][prop]["mirror"]) {
                        this.itemImages[prop].scale.x = -(Client.GameConfig.DRESSING_CONFIG[this.id]["items"][prop]["scale"]);
                    }
                    this.itemImages[prop].inputEnabled = true;
                    this.itemImages[prop].input.pixelPerfectClick = this.itemImages[prop].input.pixelPerfectOver = true;
                    this.itemImages[prop].input.pixelPerfectAlpha = 10;
                    if (Client.Globals.DEBUG) {
                        this.itemImages[prop].input.enableDrag(false, true);
                        this.itemImages[prop].input.pixelPerfectClick = true;
                        this.itemImages[prop].name = Client.GameConfig.DRESSING_CONFIG[this.id]["items"][prop]["image"];
                    }
                    else {
                        this.itemImages[prop].events.onInputOver.add(this.onScaleOver, this);
                        this.itemImages[prop].events.onInputOut.add(this.onScaleOut, this);
                        this.itemImages[prop].events.onInputDown.add(this.onItemClick, this);
                        this.itemImages[prop].name = prop;
                    }
                    this.itemImages[prop].input.useHandCursor = true;
                    this.itemGroups[prop].add(this.itemImages[prop]);
                }
                this.carousels = [];
                var caros = Client.GameConfig.DRESSING_CONFIG[this.id]["carousels"];
                if (caros) {
                    for (var i = 0; i < caros.length; i++) {
                        this.carousels[i] = new Client.Carousel(this.game, caros[i]["id"], i);
                        this.add(this.carousels[i]);
                        this.carousels[i].x = caros[i]["x"];
                        this.carousels[i].y = caros[i]["y"];
                        this.carousels[i].scale.x = this.carousels[i].scale.y = caros[i]["scale"];
                        this.carousels[i].setView(Client.Globals.DOLLS_VIEW[this.id][caros[i]["view"]]);
                        this.carousels[i].onSignal.add(this.onCarousel, this);
                    }
                }
                this.visible = true;
                this.setPage(this.page);
            };
            DressCase.prototype.onScaleOver = function (target) {
                if (!this.itemBacks[target.name]) {
                    var tmpImage = new Phaser.Image(this.game, 0, 0, Client.GameConfig.DRESSING_CONFIG[this.id]["atlas"], Client.GameConfig.DRESSING_CONFIG[this.id]["items"][target.name]["image"]);
                    var bmd = this.game.make.bitmapData();
                    bmd.load(tmpImage);
                    bmd.processPixelRGB(Client.Utils.paintWhite, this);
                    this.itemBacks[target.name] = new Phaser.Image(this.game, 0, 0, bmd);
                    this.itemBacks[target.name].filters = [this.glow];
                    this.itemBacks[target.name].anchor.setTo(Client.GameConfig.DRESSING_CONFIG[this.id]["items"][target.name]["anchor"][0], Client.GameConfig.DRESSING_CONFIG[this.id]["items"][target.name]["anchor"][1]);
                    this.itemBacks[target.name].scale.x = this.itemImages[target.name].scale.x;
                    this.itemBacks[target.name].scale.y = this.itemImages[target.name].scale.y;
                    this.itemGroups[target.name].add(this.itemBacks[target.name]);
                    this.itemGroups[target.name].setChildIndex(this.itemBacks[target.name], 0);
                }
                this.itemGroups[target.name].scale.setTo(Client.GameConfig.DRESSING_CONFIG[this.id]["items"][target.name]["scale"] + 0.05, Client.GameConfig.DRESSING_CONFIG[this.id]["items"][target.name]["scale"] + 0.05);
                this.itemBacks[target.name].visible = true;
                if (Client.GameConfig.DRESSING_CONFIG[this.id]["items"][target.name]["mirror"])
                    this.itemGroups[target.name].scale.x = -(Client.GameConfig.DRESSING_CONFIG[this.id]["items"][target.name]["scale"] + 0.05);
                if (Client.GameConfig.DRESSING_CONFIG[this.id]["items"][target.name]["dontGlow"])
                    this.itemBacks[target.name].visible = false;
            };
            DressCase.prototype.onScaleOut = function (target) {
                this.itemGroups[target.name].scale.setTo(Client.GameConfig.DRESSING_CONFIG[this.id]["items"][target.name]["scale"], Client.GameConfig.DRESSING_CONFIG[this.id]["items"][target.name]["scale"]);
                if (this.itemBacks[target.name])
                    this.itemBacks[target.name].visible = false;
                if (Client.GameConfig.DRESSING_CONFIG[this.id]["items"][target.name]["mirror"])
                    this.itemGroups[target.name].scale.x = -(Client.GameConfig.DRESSING_CONFIG[this.id]["items"][target.name]["scale"]);
            };
            DressCase.prototype.onArrowOver = function (target) {
                target.scale.x = target.scale.y = 1.05;
            };
            DressCase.prototype.onArrowOut = function (target) {
                target.scale.x = target.scale.y = 1;
            };
            DressCase.prototype.onItemClick = function (target) {
                var i, j, items, itemSet, itemId;
                for (i = 0; i < Client.GameConfig.DOLLS[this.id]["sets"].length; i++) {
                    for (j = 0; j < Client.GameConfig.DOLLS[this.id]["sets"][i].length; j++) {
                        if (Client.GameConfig.DOLLS[this.id]["sets"][i][j] == target.name) {
                            itemSet = i;
                            itemId = j;
                            if (j == Client.Globals.DOLLS_VIEW[this.id][i]) {
                                if (Client.GameConfig.DOLLS[this.id]["sets"][i][0] == null)
                                    Client.Globals.DOLLS_VIEW[this.id][i] = 0;
                            }
                            else {
                                Client.Globals.DOLLS_VIEW[this.id][i] = j;
                            }
                        }
                    }
                }
                if (Client.GameConfig.DRESSING_CONFIG[this.id]["combined"]) {
                    var combinations = Client.GameConfig.DRESSING_CONFIG[this.id]["combined"];
                    for (i = 0; i < combinations.length; i++) {
                        if (combinations[i]["set1"] == itemSet) {
                            for (var j_1 = 0; j_1 < combinations[i]["set2"].length; j_1++)
                                Client.Globals.DOLLS_VIEW[this.id][combinations[i]["set2"][j_1]] = 0;
                        }
                        for (j = 0; j < combinations[i]["set2"].length; j++) {
                            if (combinations[i]["set2"][j] == itemSet)
                                Client.Globals.DOLLS_VIEW[this.id][combinations[i]["set1"]] = 0;
                        }
                    }
                }
                if (Client.GameConfig.DRESSING_CONFIG[this.id]["notZero"]) {
                    var noZero = Client.GameConfig.DRESSING_CONFIG[this.id]["notZero"];
                    for (i = 0; i < noZero.length; i++) {
                        var dontShow = false;
                        for (var j_2 = 0; j_2 < noZero[i]["sets"].length; j_2++) {
                            if (Client.Globals.DOLLS_VIEW[this.id][noZero[i]["sets"][j_2]] > 0)
                                dontShow = true;
                        }
                        if (dontShow)
                            Client.Globals.DOLLS_VIEW[this.id][noZero[i]["image"]] = 0;
                        else
                            Client.Globals.DOLLS_VIEW[this.id][noZero[i]["image"]] = 1;
                    }
                }
                this.onSignal.dispatch({ type: this.id, name: target.name });
            };
            DressCase.prototype.onCarousel = function (data) {
                var view = Client.GameConfig.DRESSING_CONFIG[this.id]["carousels"][data["type"]]["view"];
                var caros = Client.GameConfig.DRESSING_CONFIG[this.id]["carousels"];
                Client.Globals.DOLLS_VIEW[this.id][view] = Client.Globals.DOLLS_VIEW[this.id][view] + 1;
                var set = Client.GameConfig.DOLLS[this.id]["sets"][view];
                if (Client.Globals.DOLLS_VIEW[this.id][view] >= set.length)
                    Client.Globals.DOLLS_VIEW[this.id][view] = Client.GameConfig.CAROUSELS[data["id"]]["offset"];
                this.carousels[data["type"]].setView(Client.Globals.DOLLS_VIEW[this.id][view]);
                this.onSignal.dispatch({ type: this.id });
            };
            DressCase.prototype.onArrowLeft = function (context) {
                Client.Globals.SOUND.play("button");
                if (context.page == 0)
                    context.page = Client.GameConfig.DRESSING_CONFIG[context.id]["pages"].length - 1;
                else
                    context.page--;
                context.setPage(context.page);
            };
            DressCase.prototype.onArrowRight = function (context) {
                Client.Globals.SOUND.play("button");
                if (context.page < Client.GameConfig.DRESSING_CONFIG[context.id]["pages"].length - 1)
                    context.page++;
                else
                    context.page = 0;
                context.setPage(context.page);
            };
            DressCase.prototype.setPage = function (page) {
                var items;
                this.page = page;
                for (var i_1 = 0; i_1 < this.backgrounds.length; i_1++)
                    this.backgrounds[i_1].visible = false;
                this.backgrounds[this.page].visible = true;
                for (var i = 0; i < this.veshalki.length; i++)
                    this.veshalki[i].visible = false;
                if (Client.GameConfig.DRESSING_CONFIG[this.id]["pages"] != null) {
                    for (var prop in Client.GameConfig.DRESSING_CONFIG[this.id]["pages"]) {
                        items = Client.GameConfig.DRESSING_CONFIG[this.id]["pages"][prop];
                        for (i = 0; i < items.length; i++) {
                            if (prop == page) {
                                this.itemGroups[items[i]].visible = true;
                                if (Client.GameConfig.DRESSING_CONFIG[this.id]["veshalki"]) {
                                    this.veshalki[i].visible = true;
                                    this.veshalki[i].x = Client.GameConfig.DRESSING_CONFIG[this.id]["veshalki"][this.page][i]["x"];
                                    this.veshalki[i].y = Client.GameConfig.DRESSING_CONFIG[this.id]["veshalki"][this.page][i]["y"];
                                }
                            }
                            else
                                this.itemGroups[items[i]].visible = false;
                        }
                    }
                }
            };
            Object.defineProperty(DressCase.prototype, "showArrows", {
                set: function (mode) {
                    this.setChildIndex(this.buttonsFrame, this.children.length - 1);
                    this.buttonsFrame.visible = mode;
                },
                enumerable: true,
                configurable: true
            });
            DressCase.prototype.generate = function () {
                var vesh = "";
                console.log("left: " + (this.arrowLeft.x + this.arrowLeft.mainImage.x).toString() + ":" + (this.arrowLeft.y + this.arrowLeft.mainImage.y).toString());
                console.log("right: " + (this.arrowRight.x + this.arrowRight.mainImage.x).toString() + ":" + (this.arrowRight.y + this.arrowRight.mainImage.y).toString());
                for (var prop in Client.GameConfig.DRESSING_CONFIG[this.id]["items"]) {
                    vesh = vesh + prop + ': { image: "' + this.itemImages[prop].name + '", x: ' + (this.itemImages[prop].x + this.itemGroups[prop].x) + ', y:' + (this.itemImages[prop].y + this.itemGroups[prop].y) + ', anchor: [' + Client.GameConfig.DRESSING_CONFIG[this.id]["items"][prop]["anchor"][0] + ', ' + Client.GameConfig.DRESSING_CONFIG[this.id]["items"][prop]["anchor"][1] + '], scale: ' + Client.GameConfig.DRESSING_CONFIG[this.id]["items"][prop]["scale"] + '},\n';
                }
                console.log(vesh);
                var vesh = "";
                for (var i = 0; i < this.veshalki.length; i++) {
                    if (this.veshalki[i].visible)
                        vesh = vesh + '{ x:' + this.veshalki[i].x + ', y: ' + this.veshalki[i].y + '},';
                }
                console.log(vesh);
            };
            return DressCase;
        }(Phaser.Group));
        Client.DressCase = DressCase;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Eyes = (function (_super) {
            __extends(Eyes, _super);
            function Eyes(game, atlas, id) {
                _super.call(this, game, 0, 0, atlas);
                this.animations.add('blink', Client.GameConfig.DOLLS_EYES[id]["images"], 10, false);
                this.startBlink();
            }
            Eyes.prototype.startBlink = function () {
                this.blinking = true;
                this.blink();
            };
            Eyes.prototype.blink = function () {
                if (this.blinking) {
                    var me_1 = this;
                    this.animations.play('blink');
                    this.game.time.events.add(Phaser.Timer.SECOND * 3 + Phaser.Timer.SECOND * 3 * Math.random(), function () {
                        me_1.blink();
                    }, this);
                }
            };
            Eyes.prototype.stopBlink = function () {
                this.blinking = false;
            };
            return Eyes;
        }(Phaser.Sprite));
        Client.Eyes = Eyes;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var ComixFrame = (function (_super) {
            __extends(ComixFrame, _super);
            function ComixFrame(game) {
                _super.call(this, game);
                this.waitingLoad = false;
                this.game = game;
                this.stepGroups = [];
                for (var i = 0; i < 7; i++) {
                    this.stepGroups[i] = new Phaser.Group(this.game);
                    this.add(this.stepGroups[i]);
                }
                this.dollPlace = new Phaser.Group(this.game);
                this.girl1 = new Client.AniGirl(this.game, 465, 225, 0);
                this.girl2 = new Client.AniGirl(this.game, 465, 225, 1);
                this.stepGroups[0].add(this.girl1);
                this.stepGroups[0].add(this.girl2);
                this.prince = new Phaser.Image(this.game, 50, 115, "stage1", "prince.png");
                this.stepGroups[0].add(this.prince);
                this.cloud = new Client.Cloud(this.game, 0);
                this.add(this.cloud);
                this.cloud.x = 610;
                this.cloud.y = 320;
                this.flash1 = new Phaser.Sprite(this.game, 720, 300, "stage1");
                this.flash1.animations.add("main", Phaser.Animation.generateFrameNames('flash1', 1, 10, '.png', 4), 20, true);
                this.flash1.anchor.setTo(0.5, 1);
                this.stepGroups[0].add(this.flash1);
                this.flash2 = new Phaser.Sprite(this.game, 720, 320, "stage1");
                this.flash2.animations.add("main", Phaser.Animation.generateFrameNames('flash1', 1, 10, '.png', 4), 20, true);
                this.flash2.anchor.setTo(0.5, 1);
                this.stepGroups[0].add(this.flash2);
                this.flash2.angle = 180;
                this.flash1.visible = this.flash2.visible = false;
            }
            ComixFrame.prototype.show = function (params) {
                this.config = params;
                var prince;
                var back;
                var me = this;
                for (var i = 0; i < this.stepGroups.length; i++)
                    this.stepGroups[i].visible = false;
                this.visible = true;
                if (this.particleEmitter) {
                    this.particleEmitter.kill();
                    this.remove(this.particleEmitter);
                }
                this.flash1.visible = this.flash2.visible = false;
                this.stepGroups[params["step"] - 1].visible = true;
                switch (params["step"]) {
                    case 1:
                        this.cloud.hide(true);
                        this.prince.x = -300;
                        this.girl1.x = this.girl2.x = Client.GameConfig.GAME_WIDTH + 200;
                        this.prince.anchor.x = 0;
                        this.girl1.init();
                        this.girl2.init();
                        this.girl1.y = 225;
                        this.girl2.y = 215;
                        this.girl1.scale.x = this.girl1.scale.y = this.girl2.scale.x = this.girl2.scale.y = 1;
                        this.game.add.tween(this.prince).to({ x: 50 }, 1200, Phaser.Easing.Linear.None, true, 800);
                        this.game.add.tween(this.girl1).to({ x: 465 }, 1700, Phaser.Easing.Linear.None, true, 2000);
                        this.game.add.tween(this.girl2).to({ x: 655 }, 1700, Phaser.Easing.Linear.None, true, 3000);
                        this.game.time.events.add(Phaser.Timer.SECOND * 5, function () {
                            this.particleEmitter = new Phaser.Particles.Arcade.Emitter(this.game, 700, 500, 200);
                            this.add(this.particleEmitter);
                            this.setChildIndex(this.particleEmitter, 0);
                            this.particleEmitter.makeParticles('stage1', ['heartParticle.png']);
                            this.particleEmitter.setRotation(-20, 20);
                            this.particleEmitter.setAlpha(0.5, 1, 3000);
                            this.particleEmitter.gravity = -150;
                            this.particleEmitter.minParticleScale = 0.7;
                            this.particleEmitter.maxParticleScale = 1;
                            this.particleEmitter.flow(3000, 500, 7, -1);
                        }, this);
                        this.game.time.events.add(Phaser.Timer.SECOND * 6, function () { this.cloud.show("stage1", "text1.png", true); }, this);
                        this.game.time.events.add(Phaser.Timer.SECOND * 12, function () {
                            this.cloud.show("stage1", "text2.png", false);
                            if (this.particleEmitter) {
                                this.particleEmitter.kill();
                                this.remove(this.particleEmitter);
                            }
                        }, this);
                        this.game.time.events.add(Phaser.Timer.SECOND * 17, function () {
                            this.cloud.hide();
                            this.game.add.tween(this.girl1).to({ x: 445, y: 205 }, 700, Phaser.Easing.Linear.None, true);
                            this.game.add.tween(this.girl1.scale).to({ x: 1.05, y: 1.05 }, 700, Phaser.Easing.Linear.None, true);
                            this.game.add.tween(this.girl2).to({ x: 635, y: 195 }, 700, Phaser.Easing.Linear.None, true);
                            this.game.add.tween(this.girl2.scale).to({ x: 1.05, y: 1.05 }, 700, Phaser.Easing.Linear.None, true);
                            this.girl1.start();
                            this.girl2.start();
                        }, this);
                        this.game.time.events.add(Phaser.Timer.SECOND * 18, function () {
                            this.flash1.visible = this.flash2.visible = true;
                            this.flash1.play("main");
                            this.flash2.play("main");
                            Client.Globals.onScreenEvent.dispatch({ screen: "comix", type: "over", id: this.config["buttons"] });
                        }, this);
                        break;
                    case 2:
                        this.stepGroups[1].removeAll(true);
                        this.add(this.dollPlace);
                        this.setChildIndex(this.dollPlace, 0);
                        this.prince2 = new Phaser.Image(this.game, Client.GameConfig.GAME_WIDTH + 50, 80, "stage1", "prince.png");
                        this.stepGroups[1].add(this.prince2);
                        this.prince2.anchor.x = 0.5;
                        this.cloud2 = new Client.Cloud(this.game, 1);
                        this.stepGroups[1].add(this.cloud2);
                        this.cloud2.x = 520;
                        this.cloud2.y = 220;
                        Client.Globals.DOLL_SELECTED = Math.floor(Math.random() * 2);
                        switch (Client.Globals.VERSION) {
                            case 1:
                                switch (Client.Globals.DOLL_SELECTED) {
                                    case 0:
                                        this.cloud2.x = 520;
                                        this.prince2.scale.x = this.prince2.scale.y = 0.55;
                                        this.game.time.events.add(Phaser.Timer.SECOND * 1, function () {
                                            this.game.add.tween(Client.Globals.DOLLS[1]).to({ x: 50 }, 1200, Phaser.Easing.Quadratic.In, true, 1200);
                                            this.game.add.tween(Client.Globals.DOLLS[0]).to({ x: 900 }, 1200, Phaser.Easing.Quadratic.In, true, 1400);
                                            var p1 = this.game.add.tween(this.prince2).to({ x: 480 }, 1000, Phaser.Easing.Linear.None, true);
                                            var p2 = this.game.add.tween(this.prince2).to({ x: 540 }, 1000, Phaser.Easing.Linear.None, false, 1800);
                                            p1.chain(p2);
                                        }, this);
                                        this.game.time.events.add(Phaser.Timer.SECOND * 5, function () {
                                            this.cloud2.show("stage1", "text3.png", true);
                                            Client.Globals.DOLLS_VIEW[1][6] = 1;
                                            Client.Globals.DOLLS[1].setView();
                                        }, this);
                                        this.game.time.events.add(Phaser.Timer.SECOND * 10, function () {
                                            this.cloud2.show("stage1", "text4.png", false);
                                            Client.Globals.onScreenEvent.dispatch({ screen: "comix", type: "over", id: this.config["buttons"] });
                                        }, this);
                                        break;
                                    case 1:
                                        this.cloud2.x = 350;
                                        this.prince2.scale.x = this.prince2.scale.y = 0.55;
                                        this.game.time.events.add(Phaser.Timer.SECOND * 1, function () {
                                            this.game.add.tween(Client.Globals.DOLLS[1]).to({ x: 50 }, 1200, Phaser.Easing.Quadratic.In, true, 1200);
                                            this.game.add.tween(Client.Globals.DOLLS[0]).to({ x: 900 }, 1200, Phaser.Easing.Quadratic.In, true, 1400);
                                            var p1 = this.game.add.tween(this.prince2).to({ x: 480 }, 1000, Phaser.Easing.Linear.None, true);
                                            var p2 = this.game.add.tween(this.prince2).to({ x: 400 }, 1000, Phaser.Easing.Linear.None, false, 1800);
                                            p2.onStart.add(function () {
                                                this.prince2.scale.x = -0.55;
                                            }, this);
                                            p1.chain(p2);
                                        }, this);
                                        this.game.time.events.add(Phaser.Timer.SECOND * 5, function () {
                                            this.cloud2.show("stage1", "text3.png", true);
                                            Client.Globals.DOLLS_VIEW[0][6] = 1;
                                            Client.Globals.DOLLS[0].setView();
                                        }, this);
                                        this.game.time.events.add(Phaser.Timer.SECOND * 10, function () {
                                            this.cloud2.show("stage1", "text4.png", false);
                                            Client.Globals.onScreenEvent.dispatch({ screen: "comix", type: "over", id: this.config["buttons"] });
                                        }, this);
                                        break;
                                }
                                break;
                            case 2:
                                this.prince2.scale.x = this.prince2.scale.y = 0.55;
                                this.game.time.events.add(Phaser.Timer.SECOND * 1, function () {
                                    this.game.add.tween(Client.Globals.DOLLS[1]).to({ x: 50 }, 1200, Phaser.Easing.Quadratic.In, true, 1200);
                                    this.game.add.tween(Client.Globals.DOLLS[0]).to({ x: 900 }, 1200, Phaser.Easing.Quadratic.In, true, 1400);
                                    var p1 = this.game.add.tween(this.prince2).to({ x: 480 }, 1000, Phaser.Easing.Linear.None, true);
                                    p1.onComplete.add(function () {
                                        Client.Globals.onScreenEvent.dispatch({ screen: "comix", type: "over", id: this.config["buttons"] });
                                    }, this);
                                }, this);
                                break;
                        }
                        break;
                    case 3:
                        this.stepGroups[2].removeAll(true);
                        this.add(this.dollPlace);
                        this.setChildIndex(this.dollPlace, 0);
                        for (var i = 0; i < Client.Globals.DOLLS.length; i++)
                            Client.Globals.DOLLS[i].visible = false;
                        Client.Globals.DOLLS[Client.Globals.DOLL_SELECTED].visible = true;
                        this.particleEmitter = new Phaser.Particles.Arcade.Emitter(this.game, Client.GameConfig.GAME_WIDTH / 2, 500, 400);
                        this.add(this.particleEmitter);
                        this.setChildIndex(this.particleEmitter, 0);
                        this.particleEmitter.makeParticles('stage1', ['heartParticle.png']);
                        this.particleEmitter.setRotation(-20, 20);
                        this.particleEmitter.setAlpha(0.5, 1, 3000);
                        this.particleEmitter.width = 200;
                        this.particleEmitter.gravity = -150;
                        this.particleEmitter.minParticleScale = 0.7;
                        this.particleEmitter.maxParticleScale = 1;
                        this.particleEmitter.flow(3000, 500, 7, -1);
                        this.prince3 = new Phaser.Image(this.game, 760, 30, "stage1", "prince.png");
                        this.stepGroups[2].add(this.prince3);
                        this.prince3.scale.x = -0.8;
                        this.prince3.scale.y = 0.8;
                        this.game.time.events.add(Phaser.Timer.SECOND * 2, function () {
                            Client.Globals.onScreenEvent.dispatch({ screen: "gui", type: "showPromo", id: true });
                        }, this);
                        break;
                }
            };
            ComixFrame.prototype.hide = function () {
                this.visible = false;
                this.dollPlace.removeAll(false);
                if (this.particleEmitter) {
                    this.particleEmitter.kill();
                    this.remove(this.particleEmitter);
                }
            };
            ComixFrame.prototype.makeChoose = function (target) {
                Client.Globals.onScreenEvent.dispatch({ data: "comix", id: "choose", type: target.name });
            };
            ComixFrame.prototype.showClouds = function (mode) {
            };
            ComixFrame.prototype.update = function () {
                _super.prototype.update.call(this);
                if (this.waitingLoad) {
                    if (Client.Globals.PRELOAD == 2) {
                        this.waitingLoad = false;
                        Client.Globals.onScreenEvent.dispatch({ screen: "comix", type: "over", id: this.config["buttons"] });
                    }
                }
            };
            ComixFrame.prototype.onScaleOver = function (target) {
                target.scale.setTo(1.05, 1.05);
            };
            ComixFrame.prototype.onScaleOut = function (target) {
                target.scale.setTo(1, 1);
            };
            return ComixFrame;
        }(Phaser.Group));
        Client.ComixFrame = ComixFrame;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var GuiFrame = (function (_super) {
            __extends(GuiFrame, _super);
            function GuiFrame(game) {
                _super.call(this, game);
                this.direction = 0;
                this.game = game;
                this.onClickSignal = new Phaser.Signal();
                this.music = game.add.audio('music');
                this.buttons = [];
                for (var id in Client.GameConfig.BUTTONS) {
                    this.buttons[id] = this.game.add.button(Client.GameConfig.BUTTONS[id]["x"], Client.GameConfig.BUTTONS[id]["y"], 'main', this.onClick, this, Client.GameConfig.BUTTONS[id]["images"][1], Client.GameConfig.BUTTONS[id]["images"][0], Client.GameConfig.BUTTONS[id]["images"][2]);
                    this.add(this.buttons[id]);
                    this.buttons[id].anchor.setTo(0.5, 0.5);
                    this.buttons[id].name = id;
                    this.buttons[id].events.onInputOver.add(this.onRollOver, this);
                    this.buttons[id].events.onInputOut.add(this.onRollOut, this);
                    this.buttons[id].events.onInputDown.add(this.onButtonDown, this);
                    this.buttons[id].scale.setTo(Client.GameConfig.BUTTONS[id]["scale"][0], Client.GameConfig.BUTTONS[id]["scale"][0]);
                }
                this.promoButtons = [];
                for (var i = 0; i < Client.GameConfig.PROMO.length; i++) {
                    this.promoButtons[i] = this.game.add.button(Client.GameConfig.PROMO[i]["x"], Client.GameConfig.PROMO[i]["y"], 'main', this.onPromo, this, Client.GameConfig.PROMO[i]["image"], Client.GameConfig.PROMO[i]["image"], Client.GameConfig.PROMO[i]["image"]);
                    this.add(this.promoButtons[i]);
                    this.promoButtons[i].anchor.setTo(0.5, 0.5);
                    this.promoButtons[i].name = i.toString();
                    this.promoButtons[i].events.onInputOver.add(this.onPromoOver, this);
                    this.promoButtons[i].events.onInputOut.add(this.onPromoOut, this);
                }
                this.music = game.add.audio('music', 1, true);
            }
            GuiFrame.prototype.resize = function () {
            };
            GuiFrame.prototype.onClick = function (target) {
                this.onClickSignal.dispatch({ type: target.name });
                switch (target.name) {
                    case "soundOn":
                    case "soundOff":
                        Client.Globals.SFX = !Client.Globals.SFX;
                        this.game.sound.mute = !Client.Globals.SFX;
                        this.buttons["soundOff"].visible = !Client.Globals.SFX;
                        this.buttons["soundOn"].visible = Client.Globals.SFX;
                        if (Client.Globals.SFX)
                            this.music.resume();
                        else
                            this.music.pause();
                        break;
                }
                if (Client.GameConfig.BUTTONS[target.name]["more"] && !Client.Globals.DEBUG)
                    window.open(Client.GameConfig.MORE_URL);
            };
            GuiFrame.prototype.setView = function (set) {
                for (var id in this.buttons)
                    this.buttons[id].visible = false;
                var setButtons = Client.GameConfig.BUTTONS_SET[set];
                for (var i = 0; i < setButtons.length; i++)
                    this.buttons[setButtons[i]].visible = true;
                if (this.buttons["soundOff"].visible)
                    this.buttons["soundOff"].visible = !Client.Globals.SFX;
                if (this.buttons["soundOn"].visible)
                    this.buttons["soundOn"].visible = Client.Globals.SFX;
            };
            GuiFrame.prototype.showPromo = function (mode) {
                for (var i = 0; i < Client.GameConfig.PROMO.length; i++) {
                    this.promoButtons[i].visible = mode;
                    if (mode) {
                        this.promoButtons[i].alpha = 0;
                        this.game.add.tween(this.promoButtons[i]).to({ alpha: 1 }, 1000, Phaser.Easing.Linear.None, true);
                    }
                }
            };
            GuiFrame.prototype.showLike = function (mode) {
            };
            GuiFrame.prototype.onScaleOver = function (target) {
                target.scale.setTo(1.05, 1.05);
            };
            GuiFrame.prototype.onScaleOut = function (target) {
                target.scale.setTo(1, 1);
            };
            GuiFrame.prototype.onRollOver = function (target) {
                target.scale.setTo(Client.GameConfig.BUTTONS[target.name]["scale"][1], Client.GameConfig.BUTTONS[target.name]["scale"][1]);
                if (Client.GameConfig.BUTTONS[target.name]["rotate"]) {
                    var _tween1 = this.game.add.tween(target).to({ angle: 10 }, 800, Phaser.Easing.Linear.None, true);
                    var _tween2 = this.game.add.tween(target).to({ angle: -10 }, 1600, Phaser.Easing.Linear.None, false);
                    var _tween3 = this.game.add.tween(target).to({ angle: 0 }, 800, Phaser.Easing.Linear.None, false);
                    _tween1.chain(_tween2);
                    _tween2.chain(_tween3);
                    _tween3.chain(_tween1);
                }
            };
            GuiFrame.prototype.onRollOut = function (target) {
                target.scale.setTo(Client.GameConfig.BUTTONS[target.name]["scale"][0], Client.GameConfig.BUTTONS[target.name]["scale"][0]);
                if (Client.GameConfig.BUTTONS[target.name]["rotate"]) {
                    this.game.tweens.removeFrom(target);
                    target.angle = 0;
                }
            };
            GuiFrame.prototype.onButtonDown = function (target) {
                target.scale.setTo(Client.GameConfig.BUTTONS[target.name]["scale"][2], Client.GameConfig.BUTTONS[target.name]["scale"][2]);
            };
            GuiFrame.prototype.onPromoOver = function (target) {
                target.scale.setTo(1.05, 1.05);
            };
            GuiFrame.prototype.onPromoOut = function (target) {
                target.scale.setTo(1, 1);
            };
            GuiFrame.prototype.onPromo = function (target) {
                window.open(Client.GameConfig.PROMO[target.name]["url"]);
            };
            GuiFrame.prototype.playMusic = function () {
                this.music.play();
            };
            return GuiFrame;
        }(Phaser.Group));
        Client.GuiFrame = GuiFrame;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var InterFrame = (function (_super) {
            __extends(InterFrame, _super);
            function InterFrame(game) {
                _super.call(this, game);
                this.config = { mode: "h", logo: "heart.png", delay: 500 };
                this.game = game;
                this.frame1 = new Phaser.Image(this.game, 0, 0, 'frame1');
                this.add(this.frame1);
                this.frame2 = new Phaser.Image(this.game, 0, 0, 'frame2');
                this.add(this.frame2);
                this.frameMiddle = new Phaser.Image(this.game, Client.GameConfig.GAME_WIDTH / 2, Client.GameConfig.GAME_HEIGHT / 2, 'stage1', this.config["logo"]);
                this.add(this.frameMiddle);
                this.frameMiddle.inputEnabled = true;
                this.frameMiddle.events.onInputDown.add(function () { window.open(Client.GameConfig.MORE_URL); }, this);
                this.frameMiddle.anchor.setTo(0.5, 0.5);
                this.frame1.visible = this.frame2.visible = this.frameMiddle.visible = false;
                this.frameMiddle.loadTexture;
            }
            InterFrame.prototype.transition = function (callback) {
                this.frameMiddle.alpha = 0.2;
                this.frameMiddle.scale.setTo(0.01, 0.01);
                this.frame1.visible = this.frame2.visible = this.frameMiddle.visible = true;
                switch (this.config["mode"]) {
                    case "v":
                        this.frame1.y = -Client.GameConfig.GAME_HEIGHT / 2;
                        this.frame2.y = Client.GameConfig.GAME_HEIGHT;
                        var _tween1 = this.game.add.tween(this.frame1).to({ y: 0 }, 700, Phaser.Easing.Quadratic.Out, true);
                        var _tween2 = this.game.add.tween(this.frame2).to({ y: Client.GameConfig.GAME_HEIGHT / 2 }, 700, Phaser.Easing.Quadratic.Out, true);
                        _tween1.onComplete.add(function () {
                            Client.Globals.onScreenEvent.dispatch({ screen: "interframe", id: callback });
                            this.onSignal.dispatch({ type: callback });
                            var _tween1 = this.game.add.tween(this.frame1).to({ y: -Client.GameConfig.GAME_HEIGHT / 2 }, 700, Phaser.Easing.Quadratic.Out, true, 500);
                            var _tween2 = this.game.add.tween(this.frame2).to({ y: Client.GameConfig.GAME_HEIGHT }, 700, Phaser.Easing.Quadratic.Out, true, 500);
                            var _middleTween = this.game.add.tween(this.frameMiddle.scale).to({ x: 0.01, y: 0.01 }, 700, Phaser.Easing.Cubic.Out, true, 500);
                            var _middleTween2 = this.game.add.tween(this.frameMiddle).to({ alpha: 0.2 }, 700, Phaser.Easing.Linear.None, true, 500);
                            _middleTween.onComplete.add(function () {
                                this.frame1.visible = this.frame2.visible = this.frameMiddle.visible = false;
                            }, this);
                        }, this);
                        var _middleTween = this.game.add.tween(this.frameMiddle.scale).to({ x: 1, y: 1 }, 700, Phaser.Easing.Cubic.Out, true);
                        var _middleTween2 = this.game.add.tween(this.frameMiddle).to({ alpha: 1 }, 700, Phaser.Easing.Linear.None, true);
                        break;
                    case "h":
                        this.frame1.x = -Client.GameConfig.GAME_WIDTH / 2;
                        this.frame2.x = Client.GameConfig.GAME_WIDTH;
                        var _tween1 = this.game.add.tween(this.frame1).to({ x: 0 }, 700, Phaser.Easing.Quadratic.Out, true);
                        var _tween2 = this.game.add.tween(this.frame2).to({ x: Client.GameConfig.GAME_WIDTH / 2 }, 700, Phaser.Easing.Quadratic.Out, true);
                        _tween1.onComplete.add(function () {
                            Client.Globals.onScreenEvent.dispatch({ screen: "interframe", id: callback });
                            var _tween1 = this.game.add.tween(this.frame1).to({ x: -Client.GameConfig.GAME_WIDTH / 2 }, 700, Phaser.Easing.Quadratic.Out, true, 500);
                            var _tween2 = this.game.add.tween(this.frame2).to({ x: Client.GameConfig.GAME_WIDTH }, 700, Phaser.Easing.Quadratic.Out, true, 500);
                            var _middleTween = this.game.add.tween(this.frameMiddle.scale).to({ x: 0.01, y: 0.01 }, 700, Phaser.Easing.Cubic.Out, true, 500);
                            var _middleTween2 = this.game.add.tween(this.frameMiddle).to({ alpha: 0.2 }, 700, Phaser.Easing.Linear.None, true, 500);
                            _middleTween.onComplete.add(function () {
                                this.frame1.visible = this.frame2.visible = this.frameMiddle.visible = false;
                            }, this);
                        }, this);
                        var _middleTween = this.game.add.tween(this.frameMiddle.scale).to({ x: 1, y: 1 }, 700, Phaser.Easing.Cubic.Out, true);
                        var _middleTween2 = this.game.add.tween(this.frameMiddle).to({ alpha: 1 }, 700, Phaser.Easing.Linear.None, true);
                        break;
                }
            };
            return InterFrame;
        }(Phaser.Group));
        Client.InterFrame = InterFrame;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var GlowObject = (function (_super) {
            __extends(GlowObject, _super);
            function GlowObject(game, x, y, atlas, frame, callback, context, name, glowSize, active, glow) {
                if (callback === void 0) { callback = null; }
                if (context === void 0) { context = null; }
                if (name === void 0) { name = null; }
                if (glowSize === void 0) { glowSize = 0.05; }
                if (active === void 0) { active = true; }
                if (glow === void 0) { glow = true; }
                _super.call(this, game);
                this.scaleOver = 1;
                this.glowAlways = false;
                this.game = game;
                this.glowSize = glowSize;
                this.mainImage = new Phaser.Image(game, 0, 0, atlas, frame);
                this.add(this.mainImage);
                this.mainImage.anchor.setTo(0.5, 0.5);
                this.clickCallback = callback;
                this.clickContext = context;
                this.name = name;
                this.setActive = active;
                this.setGlow = glow;
                this.x = x;
                this.y = y;
            }
            Object.defineProperty(GlowObject.prototype, "setActive", {
                set: function (mode) {
                    this.isActive = mode;
                    this.mainImage.events.destroy();
                    this.mainImage.inputEnabled = this.isActive;
                    this.mainImage.input.pixelPerfectClick = this.mainImage.input.pixelPerfectOver = true;
                    this.mainImage.input.pixelPerfectAlpha = 10;
                    this.mainImage.input.useHandCursor = this.isActive;
                    if (this.isActive) {
                        if (Client.Globals.DEBUG && this.clickCallback == null) {
                            this.mainImage.input.enableDrag(false, true);
                            this.mainImage.input.pixelPerfectClick = true;
                            this.mainImage.name = name;
                        }
                        else {
                            this.mainImage.events.onInputOver.add(this.onOver, this);
                            this.mainImage.events.onInputOut.add(this.onOut, this);
                            this.mainImage.events.onInputDown.add(this.onClick, this);
                            this.mainImage.name = name;
                        }
                    }
                },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(GlowObject.prototype, "setGlow", {
                set: function (mode) {
                    this.isGlow = mode;
                    if (this.backImage)
                        this.backImage.visible = true;
                },
                enumerable: true,
                configurable: true
            });
            GlowObject.prototype.onOver = function () {
                this.createBack();
                this.backImage.visible = true;
                this.backImage.scale.x = this.backImage.scale.y = this.mainImage.scale.x = this.mainImage.scale.y = this.scaleOver;
            };
            GlowObject.prototype.createBack = function () {
                if (!this.backImage) {
                    this.mainImage.anchor.setTo(0, 0);
                    var bmd = this.game.make.bitmapData();
                    bmd.load(this.mainImage);
                    bmd.blendSourceAtop();
                    bmd.fill(0xFF, 0xFF, 0xFF);
                    this.backImage = new Phaser.Image(this.game, 0, 0, bmd);
                    this.add(this.backImage);
                    this.backImage.filters = [new Client.GlowFilter(this.game, this.glowSize)];
                    this.setChildIndex(this.backImage, 0);
                    this.mainImage.anchor.setTo(0.5, 0.5);
                    this.backImage.anchor.setTo(0.5, 0.5);
                }
            };
            GlowObject.prototype.onOut = function () {
                if (this.backImage)
                    this.backImage.visible = this.glowAlways;
                this.backImage.scale.x = this.backImage.scale.y = this.mainImage.scale.x = this.mainImage.scale.y = 1;
            };
            GlowObject.prototype.onClick = function () {
                if (this.clickCallback)
                    this.clickCallback(this.clickContext);
                else
                    Client.Globals.onItemsEvent.dispatch({ type: "glowObject", id: this.name });
            };
            return GlowObject;
        }(Phaser.Group));
        Client.GlowObject = GlowObject;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var HeartLogo = (function (_super) {
            __extends(HeartLogo, _super);
            function HeartLogo(game) {
                _super.call(this, game);
                this.game = game;
                this.logo = new Phaser.Image(game, 0, 0, "stage1", "heart.png");
                this.whiteLine = new Phaser.Image(game, 100, 0, "stage1", "white_line.png");
                this.add(this.logo);
                this.logo.anchor.setTo(0.5, 0.5);
                var bmd = game.make.bitmapData(this.logo.width, this.logo.height);
            }
            return HeartLogo;
        }(Phaser.Group));
        Client.HeartLogo = HeartLogo;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var SceneFactory = (function () {
            function SceneFactory() {
            }
            SceneFactory.createScene = function (game, type) {
                if (type === "start") {
                    return new Client.StartScreen(game);
                }
                else if (type === "dress") {
                    return new Client.DressScreen(game);
                }
                else if (type === "preload") {
                    return new Client.PreloaderScreen(game);
                }
                return null;
            };
            return SceneFactory;
        }());
        Client.SceneFactory = SceneFactory;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var DressScreen = (function (_super) {
            __extends(DressScreen, _super);
            function DressScreen(game) {
                _super.call(this, game);
                this.game = game;
                this.dollPlace = new Phaser.Group(this.game);
                this.add(this.dollPlace);
            }
            DressScreen.prototype.onIpadDown = function (target) {
                window.open(Client.GameConfig.MORE_URL);
            };
            DressScreen.prototype.onIpadOver = function (target) {
                target.scale.setTo(1.05, 1.05);
            };
            DressScreen.prototype.onIpadOut = function (target) {
                target.scale.setTo(1, 1);
            };
            DressScreen.prototype.hide = function () {
                this.visible = false;
            };
            DressScreen.prototype.show = function (config) {
                this.config = config;
                this.removeAll();
                if (this.background)
                    this.removeChild(this.background);
                this.background = new Phaser.Image(this.game, 0, 0, this.config["background"]);
                this.add(this.background);
                this.setChildIndex(this.background, 0);
                this.add(this.dollPlace);
                this.glowBack = new Client.WhiteImage(this.game, 85, 180, "stage2", "frame1.png", 0.15);
                this.add(this.glowBack);
                this.glowBack.scale.x = this.glowBack.scale.y = 0.9;
                this.game.add.tween(this.glowBack.scale).to({ x: 1, y: 1 }, 700, Phaser.Easing.Linear.None, true, 0, -1, true);
                this.frames = [];
                for (var i = 0; i < Client.GameConfig.DOLLS.length; i++) {
                    this.frames[i] = new Client.GlowObject(this.game, 85, 180, "stage2", "frame" + (i + 1).toString() + ".png", this.onClickDoll, this);
                    this.add(this.frames[i]);
                    this.frames[i].visible = false;
                }
                this.visible = true;
                this.frames[Client.Globals.DOLL_SELECTED].visible = true;
            };
            DressScreen.prototype.onChangeDoll = function () {
                Client.Globals.onScreenEvent.dispatch({ screen: "dress", type: "changeDoll", id: Client.Globals.DOLL_SELECTED });
            };
            DressScreen.prototype.onClickDoll = function (cotext) {
                Client.Globals.DOLL_SELECTED = Client.Globals.DOLL_SELECTED == 1 ? 0 : 1;
                for (var i = 0; i < Client.GameConfig.DOLLS.length; i++)
                    cotext.frames[i].visible = false;
                cotext.frames[Client.Globals.DOLL_SELECTED].visible = true;
                Client.Globals.onScreenEvent.dispatch({ screen: "dress", type: "changeDoll", id: Client.Globals.DOLL_SELECTED });
            };
            DressScreen.prototype.updateDolls = function () {
            };
            DressScreen.prototype.onClick = function (target) {
                window.open(Client.GameConfig.MORE_URL);
            };
            DressScreen.prototype.onScaleOver = function (target) {
                target.scale.x = target.scale.y = 1.05;
            };
            DressScreen.prototype.onScaleOut = function (target) {
                target.scale.x = target.scale.y = 1;
            };
            return DressScreen;
        }(Phaser.Group));
        Client.DressScreen = DressScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var PreloaderScreen = (function (_super) {
            __extends(PreloaderScreen, _super);
            function PreloaderScreen(game) {
                _super.call(this, game);
                this.itemsConfig = [[-100, 180, 110, 270], [-100, 720, 300, 380], [480, 820, 480, 450], [1060, 720, 660, 380], [1060, 180, 850, 270]];
                this.game = game;
                this.onSignal = new Phaser.Signal();
                var background = new Phaser.Image(this.game, 0, 0, "prerollBackground");
                this.add(background);
                this.itemsImage = [];
                for (var i = 0; i < this.itemsConfig.length; i++) {
                    this.itemsImage[i] = new Phaser.Image(this.game, this.itemsConfig[i][0], this.itemsConfig[i][1], "preroll", "icon" + (i + 1).toString() + ".png");
                    this.add(this.itemsImage[i]);
                    this.itemsImage[i].inputEnabled = true;
                    this.itemsImage[i].input.useHandCursor = true;
                    this.itemsImage[i].events.onInputOver.add(this.onScaleOver, this);
                    this.itemsImage[i].events.onInputOut.add(this.onScaleOut, this);
                    this.itemsImage[i].events.onInputDown.add(this.onScaleDown, this);
                    this.itemsImage[i].anchor.setTo(0.5, 0.5);
                    var _tween = this.game.add.tween(this.itemsImage[i]).to({ x: this.itemsConfig[i][2], y: this.itemsConfig[i][3] }, 800, Phaser.Easing.Quadratic.Out, true, 1000 * i);
                }
                this.logoImage = new Phaser.Image(game, Client.GameConfig.GAME_WIDTH / 2, 170, "preroll", "logo.png");
                this.logoImage.anchor.setTo(0.5, 0.5);
                this.add(this.logoImage);
                this.logoImage.inputEnabled = true;
                this.logoImage.input.pixelPerfectClick = this.logoImage.input.pixelPerfectOver = true;
                this.logoImage.input.pixelPerfectAlpha = 10;
                this.logoImage.input.useHandCursor = true;
                this.logoImage.events.onInputOver.add(this.onScaleOver, this);
                this.logoImage.events.onInputOut.add(this.onScaleOut, this);
                this.logoImage.events.onInputDown.add(this.onScaleDown, this);
                this.glowEmitter = this.game.add.emitter(0, 0, 100);
                this.add(this.glowEmitter);
                this.glowEmitter.makeParticles("preroll", 'particle_glow.png');
                this.glowEmitter.setAlpha(1, 0.3, 3000);
                this.glowEmitter.gravity = -10;
                this.glowEmitter.minParticleScale = 0.5;
                this.glowEmitter.maxParticleScale = 1;
            }
            PreloaderScreen.prototype.onScaleOver = function (target) {
                target.scale.setTo(1.05, 1.05);
                Client.Globals.HOVER = true;
            };
            PreloaderScreen.prototype.onScaleOut = function (target) {
                target.scale.setTo(1, 1);
                Client.Globals.HOVER = false;
            };
            PreloaderScreen.prototype.onScaleDown = function (target) {
                window.open(Client.GameConfig.MORE_URL);
            };
            PreloaderScreen.prototype.update = function () {
                _super.prototype.update.call(this);
                if (Client.Globals.HOVER) {
                    this.glowEmitter.x = this.game.input.x;
                    this.glowEmitter.y = this.game.input.y;
                    this.glowEmitter.start(true, 3000, null, 25);
                }
            };
            PreloaderScreen.prototype.hide = function () {
                this.visible = false;
                this.glowEmitter.kill();
                Client.Globals.HOVER = false;
            };
            PreloaderScreen.prototype.show = function (config) {
                this.config = config;
                this.visible = true;
            };
            return PreloaderScreen;
        }(Phaser.Group));
        Client.PreloaderScreen = PreloaderScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        "use strict";
        var StartScreen = (function (_super) {
            __extends(StartScreen, _super);
            function StartScreen(game) {
                _super.call(this, game);
                this.game = game;
                this.add(new Phaser.Image(this.game, 0, 0, 'back0'));
                this.eyes = [];
                for (var i = 0; i < Client.GameConfig.DOLLS_EYES.length; i++) {
                    this.eyes[i] = new Client.Eyes(this.game, "stage1", i);
                    this.add(this.eyes[i]);
                    this.eyes[i].x = Client.GameConfig.DOLLS_EYES[i]["place"][0];
                    this.eyes[i].y = Client.GameConfig.DOLLS_EYES[i]["place"][1];
                    this.eyes[i].startBlink();
                    if (Client.Globals.DEBUG) {
                        this.eyes[i].inputEnabled = true;
                        this.eyes[i].input.pixelPerfectClick = true;
                        this.eyes[i].input.enableDrag(false, true);
                        this.eyes[i].input.pixelPerfectClick = true;
                    }
                }
                this.startGroup = new Phaser.Group(this.game);
                this.add(this.startGroup);
                this.logoHello = new Client.GlowObject(this.game, Client.GameConfig.GAME_WIDTH / 2, 500, "stage1", "heart.png", function () { Client.Globals.onScreenEvent.dispatch({ screen: "gui", type: "more" }); }, this);
                this.logoHello.scaleOver = 1.05;
                this.add(this.logoHello);
                this.stageGroup = new Phaser.Group(this.game, this);
                this.add(this.stageGroup);
            }
            StartScreen.prototype.hide = function () {
                this.game.tweens.removeFrom(this.logoHello);
                if (this.logoHello.backImage) {
                    this.game.tweens.removeFrom(this.logoHello.backImage);
                    this.logoHello.backImage.scale.x = this.logoHello.backImage.scale.y = 1;
                }
                this.logoHello.scale.x = this.logoHello.scale.y = 1;
                this.visible = false;
            };
            StartScreen.prototype.show = function (config) {
                this.config = config;
                var backStage;
                this.hide();
                for (var i = 0; i < this.eyes.length; i++)
                    this.eyes[i].startBlink();
                this.visible = true;
                this.logoHello.visible = false;
                this.stageGroup.removeAll(true);
                for (var i = 0; i < this.eyes.length; i++)
                    this.eyes[i].visible = false;
                switch (config["step"]) {
                    case 1:
                        this.logoHello.visible = true;
                        this.game.add.tween(this.logoHello.scale).to({ x: 1.03, y: 1.03 }, 1200, Phaser.Easing.Quadratic.In, true, 0, -1, true);
                        this.logoHello.createBack();
                        this.logoHello.glowAlways = true;
                        this.game.add.tween(this.logoHello.backImage.scale).to({ x: 1.05, y: 1.05 }, 1200, Phaser.Easing.Quadratic.In, true, 0, -1, true);
                        this.logoHello.scale.x = this.logoHello.scale.y = 1;
                        break;
                    case 2:
                        this.stageGroup.add(this.game.add.image(0, 0, "back1"));
                        break;
                    case 3:
                        this.stageGroup.add(this.game.add.image(0, 0, "back" + (Client.Globals.BACKGROUND + 1).toString()));
                        break;
                }
            };
            StartScreen.prototype.onGirlOver = function (target) {
            };
            StartScreen.prototype.onGirlOut = function (target) {
            };
            StartScreen.prototype.onPromoOver = function (target) {
                target.scale.setTo(1.05, 1.05);
            };
            StartScreen.prototype.onPromoOut = function (target) {
                target.scale.setTo(1, 1);
            };
            StartScreen.prototype.onPromoDown = function (target) {
                window.open(Client.GameConfig.MORE_URL);
            };
            return StartScreen;
        }(Phaser.Group));
        Client.StartScreen = StartScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var WhiteImage = (function (_super) {
            __extends(WhiteImage, _super);
            function WhiteImage(game, x, y, atlas, frame, glowSize) {
                if (glowSize === void 0) { glowSize = 0.15; }
                _super.call(this, game, x, y, atlas, frame);
                var bmd = this.game.make.bitmapData();
                bmd.load(new Phaser.Image(this.game, 0, 0, atlas, frame));
                bmd.blendSourceAtop();
                bmd.fill(0xFF, 0xFF, 0xFF);
                this.loadTexture(bmd);
                this.filters = [new Client.GlowFilter(this.game, glowSize)];
                this.anchor.setTo(0.5, 0.5);
            }
            return WhiteImage;
        }(Phaser.Image));
        Client.WhiteImage = WhiteImage;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var MainState = (function (_super) {
            __extends(MainState, _super);
            function MainState() {
                _super.apply(this, arguments);
                this.screens = [];
            }
            MainState.prototype.create = function () {
                var me = this;
                Client.Globals.SOUND = this.game.add.audio('sfx');
                Client.Globals.SOUND.allowMultiple = true;
                Client.Globals.SOUND.addMarker('button', 0, 0.116);
                Client.Globals.SOUND.addMarker('photo', 1, 0.5);
                Client.Globals.SOUND.addMarker('finale', 1.994, 5);
                this.screens = [];
                for (var i = 0; i < Client.GameConfig.STAGES["stageTypes"].length; i++) {
                    this.screens[Client.GameConfig.STAGES["stageTypes"][i]] = Client.SceneFactory.createScene(this.game, Client.GameConfig.STAGES["stageTypes"][i]);
                }
                this.hideStages();
                Client.Globals.CASE = new Client.DressCase(this.game);
                Client.Globals.CASE.onSignal.add(this.onCase, this);
                this.arrowsGroup = new Phaser.Group(this.game);
                this.comixFrame = new Client.ComixFrame(this.game);
                this.comixFrame.hide();
                this.backgroundsGroup = new Phaser.Group(this.game);
                this.buttonsFrame = new Client.GuiFrame(this.game);
                this.buttonsFrame.onClickSignal.add(this.onClickButtons, this);
                this.buttonsFrame.showPromo(false);
                this.buttonsFrame.visible = false;
                this.interFrame = new Client.InterFrame(this.game);
                Client.Globals.onScreenEvent.add(this.onScreenEvent, this);
                this.initGame();
                this.initObjects();
            };
            MainState.prototype.initGame = function () {
                this.clearDolls();
                this.buttonsFrame.visible = true;
                this.buttonsFrame.playMusic();
                this.showStage(0);
                this.buttonsFrame.setView(Client.GameConfig.STAGES["stages"][Client.Globals.STAGE]["buttons"]);
            };
            MainState.prototype.onScreenEvent = function (data) {
                switch (data["screen"]) {
                    case "gui":
                        switch (data["type"]) {
                            case "showPromo":
                                this.buttonsFrame.showPromo(data["id"]);
                                break;
                            case "more":
                                window.open(Client.GameConfig.MORE_URL);
                                break;
                        }
                        break;
                    case "start":
                        if (data["type"] == "girls") {
                            Client.Globals.SOUND.play("button");
                            Client.Globals.DOLL_SELECTED = Number(data["id"]);
                            Client.Globals.STAGE = Client.GameConfig.STAGES["stages"][Client.Globals.STAGE]["next"];
                            this.interFrame.transition("next");
                        }
                        break;
                    case "dress":
                        switch (data["type"]) {
                            case "changeDoll":
                                Client.Globals.SOUND.play("button");
                                Client.Globals.DOLL_SELECTED = data["id"];
                                this.updateDolls();
                                Client.Globals.CASE.setView(Client.Globals.DOLL_SELECTED, 0);
                                break;
                        }
                        break;
                    case "comix":
                        switch (data["type"]) {
                            case "over":
                                this.buttonsFrame.setView(data["id"]);
                                break;
                        }
                        break;
                    case "interframe":
                        this.hideStages();
                        this.buttonsFrame.setView(Client.GameConfig.STAGES["stages"][Client.Globals.STAGE]["buttons"]);
                        this.showStage(Client.Globals.STAGE);
                        break;
                    case "preloader":
                        this.initObjects();
                        break;
                }
            };
            MainState.prototype.onTransition = function (data) {
                switch (data["type"]) {
                    case "next":
                        break;
                }
                this.hideStages();
                this.buttonsFrame.setView(Client.GameConfig.STAGES["stages"][Client.Globals.STAGE]["buttons"]);
                this.showStage(Client.Globals.STAGE);
            };
            MainState.prototype.onCase = function (data) {
                Client.Globals.SOUND.play("button");
                Client.Globals.DOLLS[data["type"]].setView();
                Client.Globals.DOLL_DONE[Client.Globals.DOLL_SELECTED] = true;
                if (Client.Globals.DOLL_DONE[0] && Client.Globals.DOLL_DONE[1])
                    this.buttonsFrame.setView(Client.GameConfig.STAGES["stages"][Client.Globals.STAGE]["params"]["buttons"]);
                var views = Client.Globals.DOLLS_VIEW[Client.Globals.DOLL_SELECTED];
                Client.Globals.DOLLS_SCORE[Client.Globals.DOLL_SELECTED] = 0;
                for (var i = 0; i < views.length; i++) {
                    if (views[i] == Client.Globals.DRESS_SELECTED + 1)
                        Client.Globals.DOLLS_SCORE[Client.Globals.DOLL_SELECTED] = Client.Globals.DOLLS_SCORE[Client.Globals.DOLL_SELECTED] + Client.Globals.SCORE_VIEW[i];
                }
                if (data["name"] == "more")
                    window.open(Client.GameConfig.MORE_URL);
            };
            MainState.prototype.onPlay = function () {
            };
            MainState.prototype.onScenePhoto = function (target) {
                if (Client.Globals.PLACE_ID == Number(target.name)) {
                    Client.Globals.SOUND.play("button");
                    Client.Globals.STAGE = Number(target.name) + 3;
                    this.interFrame.transition("next");
                }
            };
            MainState.prototype.hideStages = function () {
                for (var id in this.screens) {
                    this.screens[id].hide();
                }
            };
            MainState.prototype.showStage = function (id) {
                this.screens[Client.GameConfig.STAGES["stages"][id]["screen"]].show(Client.GameConfig.STAGES["stages"][id]["params"]);
                if (Client.Globals.DOLLS)
                    for (var i = 0; i < Client.Globals.DOLLS.length; i++)
                        Client.Globals.DOLLS[i].visible = false;
                if (Client.GameConfig.STAGES["stages"][id]["params"]["dolls"]) {
                    var paramDolls = Client.GameConfig.STAGES["stages"][id]["params"]["dolls"];
                    for (var i = 0; i < paramDolls.length; i++) {
                        Client.Globals.DOLLS[paramDolls[i]["id"]].scale.x = Client.Globals.DOLLS[paramDolls[i]["id"]].scale.y = paramDolls[i]["scale"];
                        if (paramDolls[i]["mirror"])
                            Client.Globals.DOLLS[paramDolls[i]["id"]].scale.x = -paramDolls[i]["scale"];
                        if (paramDolls[i]["comix"])
                            this.comixFrame.dollPlace.add(Client.Globals.DOLLS[paramDolls[i]["id"]]);
                        else {
                            this.screens[Client.GameConfig.STAGES["stages"][id]["screen"]].add(Client.Globals.DOLLS[paramDolls[i]["id"]]);
                        }
                        Client.Globals.DOLLS[paramDolls[i]["id"]].x = paramDolls[i]["x"];
                        Client.Globals.DOLLS[paramDolls[i]["id"]].y = paramDolls[i]["y"];
                        Client.Globals.DOLLS[paramDolls[i]["id"]].visible = true;
                        Client.Globals.DOLLS[paramDolls[i]["id"]].setView();
                    }
                }
                if (Client.GameConfig.STAGES["stages"][id]["comix"])
                    this.comixFrame.show(Client.GameConfig.STAGES["stages"][id]["comix"]);
                else
                    this.comixFrame.hide();
                if (Client.GameConfig.STAGES["stages"][id]["showAds"])
                    Client.Utils.showAds();
                if (Client.GameConfig.STAGES["stages"][id]["like"])
                    this.buttonsFrame.showLike(true);
                else
                    this.buttonsFrame.showLike(false);
                if (Client.GameConfig.STAGES["stages"][id]["promo"])
                    this.buttonsFrame.showPromo(true);
                else
                    this.buttonsFrame.showPromo(false);
                Client.Globals.CASE.visible = this.arrowsGroup.visible = this.backgroundsGroup.visible = false;
                if (Client.GameConfig.STAGES["stages"][id]["params"]["case"] != undefined) {
                    this.screens[Client.GameConfig.STAGES["stages"][id]["screen"]].add(Client.Globals.CASE);
                    Client.Globals.DOLL_SELECTED = Client.GameConfig.STAGES["stages"][id]["params"]["case"];
                    Client.Globals.CASE.setView(Client.GameConfig.STAGES["stages"][id]["params"]["case"]);
                    Client.Globals.CASE.showArrows = true;
                    this.updateDolls();
                    if (Client.Globals.PLACE_ID > 3)
                        this.buttonsFrame.setView("next");
                }
            };
            MainState.prototype.onComix = function (data) {
                switch (data["type"]) {
                    case "candy":
                        Client.Globals.SOUND.play("button");
                        if (data["amount"] == 0) {
                            Client.Globals.STAGE = Client.GameConfig.STAGES["stages"][Client.Globals.STAGE]["comix"]["yes"];
                            this.interFrame.transition("next");
                        }
                        break;
                    case "over":
                        this.buttonsFrame.setView(data["set"]);
                        break;
                    case "yes":
                        Client.Globals.SOUND.play("button");
                        Client.Globals.STAGE = Client.GameConfig.STAGES["stages"][Client.Globals.STAGE]["comix"]["yes"];
                        this.interFrame.transition("next");
                        break;
                    case "no":
                        Client.Globals.SOUND.play("button");
                        Client.Globals.STAGE = Client.GameConfig.STAGES["stages"][Client.Globals.STAGE]["comix"]["no"];
                        this.interFrame.transition("next");
                        break;
                    case "place":
                        Client.Globals.SOUND.play("button");
                        if (data["id"] != 3) {
                            Client.Globals.PLACE_ID = data["id"];
                            Client.Globals.BACKGROUND = Number(data["id"]) + 1;
                        }
                        else
                            Client.Globals.PLACE_ID = -1;
                        Client.Globals.STAGE = 3;
                        this.interFrame.transition("next");
                        break;
                    case "photo":
                        Client.Globals.STAGE = Client.GameConfig.STAGES["stages"][Client.Globals.STAGE]["next"];
                        Client.Globals.PLACE_ID = data["id"] + 1;
                        if (Client.Globals.PLACE_ID > 3)
                            Client.Globals.STAGE = 7;
                        this.interFrame.transition("next");
                        Client.Globals.SOUND.play("photo");
                        break;
                    case "final":
                        this.buttonsFrame.showPromo(true);
                        this.buttonsFrame.setView(data["set"]);
                        break;
                }
            };
            MainState.prototype.onClickButtons = function (data) {
                switch (data["type"]) {
                    case "next":
                    case "play":
                    case "replay":
                    case "skip":
                        Client.Globals.SOUND.play("button");
                        if (Client.Globals.STAGE == 7 && data["type"] == "next") {
                            this.buttonsFrame.setView("promo");
                            this.buttonsFrame.showPromo(true);
                        }
                        else {
                            if (Client.GameConfig.STAGES["stages"][Client.Globals.STAGE]["reset"])
                                this.clearDolls();
                            if (Client.GameConfig.STAGES["stages"][Client.Globals.STAGE]["alldolls"]) {
                                var allDone = true;
                                for (var i = 0; i < Client.Globals.DOLL_DONE.length; i++)
                                    allDone = allDone && Client.Globals.DOLL_DONE[i];
                                if (allDone)
                                    Client.Globals.STAGE = Client.GameConfig.STAGES["stages"][Client.Globals.STAGE]["alldolls"];
                                else
                                    Client.Globals.STAGE = Client.GameConfig.STAGES["stages"][Client.Globals.STAGE]["next"];
                            }
                            else
                                Client.Globals.STAGE = Client.GameConfig.STAGES["stages"][Client.Globals.STAGE]["next"];
                            if (Client.GameConfig.STAGES["stages"][Client.Globals.STAGE]["loop"])
                                this.loopGame();
                            this.interFrame.transition("next");
                        }
                        break;
                    case "more":
                        if (Client.Globals.DEBUG)
                            Client.Globals.CASE.generate();
                        break;
                    case "photo":
                        this.buttonsFrame.setView("photo");
                        this.buttonsFrame.showPromo(false);
                        this.comixFrame.showClouds(false);
                        this.game.time.events.add(Phaser.Timer.SECOND / 4, function () { Client.Utils.saveCanvas(this.game); }, this);
                        this.game.time.events.add(Phaser.Timer.SECOND / 2, function () {
                            this.buttonsFrame.setView("promo");
                            this.buttonsFrame.showPromo(true);
                            this.comixFrame.showClouds(true);
                        }, this);
                        break;
                }
            };
            MainState.prototype.updateDolls = function () {
                this.screens["dress"].updateDolls();
                for (var i = 0; i < Client.Globals.DOLLS.length; i++) {
                    if (Client.Globals.DOLL_SELECTED == i) {
                        Client.Globals.DOLLS[i].visible = true;
                        Client.Globals.CASE.setView(i);
                    }
                    else
                        Client.Globals.DOLLS[i].visible = false;
                }
            };
            MainState.prototype.loopGame = function () {
                switch (Client.Globals.PLACE_ID) {
                    case 0:
                        Client.Globals.PLACE_ID = 1;
                        break;
                    case 1:
                        Client.Globals.PLACE_ID = 2;
                        break;
                    case 2:
                        Client.Globals.PLACE_ID = -1;
                        break;
                    case -1:
                        Client.Globals.STAGE = 6;
                        break;
                }
            };
            MainState.prototype.clearDolls = function () {
                for (var i = 0; i < Client.GameConfig.VIEW_START.length; i++)
                    Client.Globals.DOLLS_VIEW[i] = Client.GameConfig.VIEW_START[i].slice();
                Client.Globals.DOLL_DONE = [false, false, false];
                Client.Globals.DRESS_DONE = [false, false, false, false, false, false];
                Client.Globals.DRESS_SELECTED = 0;
                Client.Globals.DOLL_SELECTED = 0;
                Client.Globals.DOLLS_SCORE = [0, 0, 0];
                Client.Globals.PLACE_ID = 0;
                Client.Globals.BACKGROUND = 0;
            };
            MainState.prototype.onArrowOver = function (target) {
                target.scale.x = target.scale.y = 1.05;
            };
            MainState.prototype.onArrowOut = function (target) {
                target.scale.x = target.scale.y = 1;
            };
            MainState.prototype.initObjects = function () {
                if (Client.Globals.PRELOAD == 2) {
                    Client.Globals.DOLLS = [];
                    for (var i = 0; i < Client.GameConfig.DOLLS.length; i++) {
                        Client.Globals.DOLLS[i] = new Client.Doll(this.game, i);
                        Client.Globals.DOLLS[i].setActive(false);
                        Client.Globals.DOLLS[i].visible = false;
                    }
                }
            };
            return MainState;
        }(Phaser.State));
        Client.MainState = MainState;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var BootState = (function (_super) {
            __extends(BootState, _super);
            function BootState() {
                _super.apply(this, arguments);
            }
            BootState.prototype.preload = function () {
                this.load.image('prerollBackground', './assets/backgrounds/preroll_back.jpg');
                var path = "./assets/sprites/";
                var suffix = "";
                if (Client.Globals.DEBUG)
                    suffix = '?r=' + Math.random();
                this.load.atlas("preroll", path + "preloader_atlas.png", path + "preloader_atlas.json" + suffix);
                this.stage.disableVisibilityChange = true;
            };
            BootState.prototype.create = function () {
                this.input.maxPointers = 1;
                this.scale.pageAlignHorizontally = true;
                this.scale.pageAlignVertically = true;
                this.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
                this.game.state.start('Preloader', true, false);
            };
            return BootState;
        }(Phaser.State));
        Client.BootState = BootState;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var PreloaderState = (function (_super) {
            __extends(PreloaderState, _super);
            function PreloaderState() {
                _super.apply(this, arguments);
            }
            PreloaderState.prototype.preload = function () {
                var preloader = Client.SceneFactory.createScene(this.game, "preload");
                this.preloadBack = this.add.image(0, 580, 'preroll', 'progressbar_2.png');
                this.preloadBar = this.add.sprite(this.game.world.centerX - 620 / 2, 580, 'preroll', 'progressbar_1.png');
                this.load.setPreloadSprite(this.preloadBar);
                this.preloadBar.x = this.preloadBack.x = this.game.world.centerX - this.preloadBack.width / 2;
                this.load.image('prerollBack', './assets/backgrounds/preroll_back.jpg');
                this.load.image('back0', './assets/backgrounds/back0.jpg');
                this.load.image('back1', './assets/backgrounds/back1.jpg');
                this.load.image('frame1', './assets/backgrounds/frameLeft.jpg');
                this.load.image('frame2', './assets/backgrounds/frameRight.jpg');
                var suffix = "";
                if (Client.Globals.DONT_CACHE)
                    suffix = '?r=' + Math.random();
                this.load.atlasJSONHash('main', './assets/sprites/gui.png' + suffix, './assets/sprites/gui.json' + suffix);
                this.load.atlasJSONHash('stage1', './assets/sprites/stage1.png' + suffix, './assets/sprites/stage1.json' + suffix);
                this.load.image('dressingBack', './assets/backgrounds/back2.jpg');
                this.load.atlasJSONHash('doll1', './assets/sprites/doll1.png' + suffix, './assets/sprites/doll1.json' + suffix);
                this.load.atlasJSONHash('doll2', './assets/sprites/doll2.png' + suffix, './assets/sprites/doll2.json' + suffix);
                this.load.atlasJSONHash('stage2', './assets/sprites/stage2.png' + suffix, './assets/sprites/stage2.json' + suffix);
                this.load.audio('sfx', './assets/sounds/sounds.mp3');
                this.load.audio('music', './assets/sounds/music.mp3');
            };
            PreloaderState.prototype.create = function () {
                this.preloadBack.visible = this.preloadBar.visible = false;
                this.playButton = this.game.add.button(Client.GameConfig.GAME_WIDTH / 2, 620, "preroll", function () { this.game.state.start('MainMenu'); }, this, "play_normal.png", "play_normal.png", "play_over.png");
                this.playButton.anchor.setTo(0.5, 0.5);
                this.playButton.scale.x = this.playButton.scale.y = 0.1;
                var _buttonTween = this.game.add.tween(this.playButton.scale).to({ x: 1, y: 1 }, 1000, Phaser.Easing.Elastic.Out, true);
                this.playButton.events.onInputOver.add(this.onButtonOver, this);
                this.playButton.events.onInputOut.add(this.onButtonOut, this);
                this.preloader();
            };
            PreloaderState.prototype.onButtonOver = function (target) {
                target.scale.x = target.scale.y = 1.05;
            };
            PreloaderState.prototype.onButtonOut = function (target) {
                target.scale.x = target.scale.y = 1;
            };
            PreloaderState.prototype.preloader = function () {
                this.load.onLoadComplete.removeAll();
                Client.Globals.PRELOAD = 1;
                var suffix = "";
                if (Client.Globals.DONT_CACHE)
                    suffix = '?r=' + Math.random();
                this.load.onLoadComplete.add(this.preloaderDone, this);
                this.load.start();
            };
            PreloaderState.prototype.preloaderDone = function () {
                Client.Globals.PRELOAD = 2;
                Client.Globals.onScreenEvent.dispatch({ screen: "preloader" });
            };
            return PreloaderState;
        }(Phaser.State));
        Client.PreloaderState = PreloaderState;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var GlowFilter = (function (_super) {
            __extends(GlowFilter, _super);
            function GlowFilter(game, size) {
                var fragmentSrc = [
                    "precision lowp float;",
                    "varying vec2 vTextureCoord;",
                    "varying vec4 vColor;",
                    'uniform sampler2D uSampler;',
                    'void main() {',
                    'vec4 sum = vec4(0);',
                    'vec2 texcoord = vTextureCoord;',
                    'for(int xx = -4; xx <= 4; xx++) {',
                    'for(int yy = -3; yy <= 3; yy++) {',
                    'float dist = sqrt(float(xx*xx) + float(yy*yy));',
                    'float factor = 0.0;',
                    'if (dist == 0.0) {',
                    'factor = 2.0;',
                    '} else {',
                    'factor = 2.0/abs(float(dist));',
                    '}',
                    'sum += texture2D(uSampler, texcoord + vec2(xx, yy) * 0.002) * factor;',
                    '}',
                    '}',
                    'gl_FragColor = sum * ' + size + ' + texture2D(uSampler, texcoord);',
                    '}'
                ];
                _super.call(this, game, null, fragmentSrc);
            }
            return GlowFilter;
        }(Phaser.Filter));
        Client.GlowFilter = GlowFilter;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var GrayFilter = (function (_super) {
            __extends(GrayFilter, _super);
            function GrayFilter(game) {
                var fragmentSrc = [
                    "precision mediump float;",
                    "varying vec2       vTextureCoord;",
                    "varying vec4       vColor;",
                    "uniform sampler2D  uSampler;",
                    "uniform float      gray;",
                    "void main(void) {",
                    "gl_FragColor = texture2D(uSampler, vTextureCoord);",
                    "gl_FragColor.rgb = mix(gl_FragColor.rgb, vec3(0.2126 * gl_FragColor.r + 0.7152 * gl_FragColor.g + 0.0722 * gl_FragColor.b), gray);",
                    "}"
                ];
                _super.call(this, game, null, fragmentSrc);
                this.uniforms.gray = { type: '1f', value: 1.0 };
            }
            return GrayFilter;
        }(Phaser.Filter));
        Client.GrayFilter = GrayFilter;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var LinesFilter = (function (_super) {
            __extends(LinesFilter, _super);
            function LinesFilter(game) {
                var fragmentSrc = [
                    "precision mediump float;",
                    "uniform float     time;",
                    "uniform vec2      resolution;",
                    "void main( void ) {",
                    "vec2 p = ( gl_FragCoord.xy / resolution.xy ) - 0.5;",
                    "float sx = 0.2*sin( 25.0 * p.y - time * 5.);",
                    "float dy = 3.9/ ( 50. * abs(p.y - sx));",
                    "gl_FragColor = vec4( (p.x + 0.5) * dy, 0.5 * dy, dy-1.65, 5.0 );",
                    "}"
                ];
                _super.call(this, game, null, fragmentSrc);
            }
            return LinesFilter;
        }(Phaser.Filter));
        Client.LinesFilter = LinesFilter;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var OutlineFilter = (function (_super) {
            __extends(OutlineFilter, _super);
            function OutlineFilter(game, thickness) {
                var fragmentSrc = [
                    'precision mediump float;',
                    'varying vec2 vTextureCoord;',
                    'uniform sampler2D texture;',
                    'uniform float thickness;',
                    'uniform vec4 outlineColor;',
                    'uniform float pixelWidth;',
                    'uniform float pixelHeight;',
                    'vec2 px = vec2(pixelWidth, pixelHeight);',
                    'void main(void) {',
                    '    const float PI = 3.14159265358979323846264;',
                    '    vec4 ownColor = texture2D(texture, vTextureCoord);',
                    '    vec4 curColor;',
                    '    float maxAlpha = 0.;',
                    '    for (float angle = 0.; angle < PI * 2.; angle += ' + (1 / thickness).toFixed(7) + ') {',
                    '        curColor = texture2D(texture, vec2(vTextureCoord.x + thickness * px.x * cos(angle), vTextureCoord.y + thickness * px.y * sin(angle)));',
                    '        maxAlpha = max(maxAlpha, curColor.a);',
                    '    }',
                    '    float resultAlpha = max(maxAlpha, ownColor.a);',
                    '    gl_FragColor = vec4((ownColor.rgb + outlineColor.rgb * (1. - ownColor.a)) * resultAlpha, resultAlpha);',
                    '}'
                ];
                _super.call(this, game, null, fragmentSrc);
            }
            return OutlineFilter;
        }(Phaser.Filter));
        Client.OutlineFilter = OutlineFilter;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Utils = (function () {
            function Utils() {
            }
            Utils.inArray = function (needle, haystack) {
                var length = haystack.length;
                for (var i = 0; i < length; i++) {
                    if (haystack[i] == needle)
                        return true;
                }
                return false;
            };
            Utils.saveCanvas = function (game) {
                var link = document.createElement('a');
                link.href = game.canvas.toDataURL('image/png');
                link.download = Client.GameConfig.FILENAME;
                document.body.appendChild(link);
                link.click();
                document.body.removeChild(link);
            };
            Utils.hide = function (elements) {
                elements = elements.length ? elements : [elements];
                for (var index = 0; index < elements.length; index++) {
                    elements[index].style.display = 'none';
                }
            };
            Utils.paintWhite = function (pixel) {
                pixel.r = pixel.g = pixel.b = 255;
                return pixel;
            };
            Utils.showAds = function () {
                if (areAdsEnabled())
                    playAds();
            };
            Utils.musicOn = function () {
                Client.Globals.onScreenEvent.dispatch({ screen: "gui", type: "musicOn" });
            };
            Utils.musicOff = function () {
                Client.Globals.onScreenEvent.dispatch({ screen: "gui", type: "musicOff" });
            };
            Utils.makeShoot = function (game, w, h, object) {
                var bmd = game.add.bitmapData(w, h);
                var oldTrans = { x: object.x, y: object.y, scaleX: object.scale.x, scaleY: object.scale.y, angle: object.angle };
                object.x = object.y = 0;
                object.scale.x = object.scale.y = 1;
                object.angle = 0;
                object.updateTransform();
                bmd.drawGroup(object);
                object.x = oldTrans.x;
                object.y = oldTrans.y;
                object.scale.x = oldTrans.scaleX;
                object.scale.y = oldTrans.scaleY;
                object.angle = oldTrans.angle;
                object.updateTransform();
                return bmd;
            };
            return Utils;
        }());
        Client.Utils = Utils;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var GameConfig = (function () {
            function GameConfig() {
            }
            GameConfig.PROMO = [{ url: "http://freegamescasual.com/Free-Online-Games/Princesses/Princess-Zumba-Dancers.html", image: "promo1.png", x: 110, y: 410 }, { url: "http://freegamescasual.com/Free-Online-Games/Princesses/Princesses-Masquerade-Trial-HTML5.html", image: "promo2.png", x: 850, y: 410 },];
            GameConfig.FILENAME = "PrincessBoyfriendRivals.png";
            GameConfig.GAME_WIDTH = 960;
            GameConfig.GAME_HEIGHT = 720;
            GameConfig.MORE_URL = "http://freegamescasual.com/?owngames_PrincessesBoyfriendRivals=";
            GameConfig.PREROLLITEMS = {
                dress: { image: "dress.png", position: [789, 396], birka: "birka_dress.png", birkaAnchor: [0, 0], birkaPosition: [-45, -220] },
                makeup: { image: "makeup.png", position: [340, 376], birka: "birka_makeup.png", birkaAnchor: [1, 0.5], birkaPosition: [-50, -20] },
                hair: { image: "hair.png", position: [153, 473], birka: "birka_hair.png", birkaAnchor: [0, 0], birkaPosition: [-75, 50] },
            };
            GameConfig.BUTTONS = {
                play: { images: ["play_normal.png", "play_normal.png", "play_down.png"], x: 70, y: 650, scale: [1, 1.05, 1] },
                next: { images: ["next_normal.png", "next_normal.png", "next_down.png"], x: 70, y: 650, scale: [1, 1.05, 1] },
                photo: { images: ["photo_normal.png", "photo_normal.png", "photo_down.png"], x: 890, y: 180, scale: [1.5, 1.55, 1.5] },
                replay: { images: ["replay_normal.png", "replay_normal.png", "replay_down.png"], x: 70, y: 650, scale: [1, 1.05, 1] },
                more: { images: ["more_normal.png", "more_normal.png", "more_down.png"], x: 890, y: 650, scale: [1, 1.05, 1], more: true },
                dressup: { images: ["logo_fgc_normal.png", "logo_fgc_normal.png", "logo_fgc_down.png"], x: 820, y: 60, scale: [1.3, 1.35, 1.3], more: true },
                soundOn: { images: ["soundOn_normal.png", "soundOn_normal.png", "soundOn_down.png"], x: 60, y: 55, scale: [1, 1.05, 1] },
                soundOff: { images: ["soundOff_normal.png", "soundOff_normal.png", "soundOn_down.png"], x: 60, y: 55, scale: [1, 1.05, 1] }
            };
            GameConfig.BUTTONS_SET = {
                start: ["play", "soundOn", "soundOff", "more", "dressup"],
                main: ["soundOn", "soundOff", "more", "dressup"],
                next: ["next", "soundOn", "soundOff", "more", "dressup"],
                done: ["soundOn", "soundOff", "more", "dressup"],
                promo: ["photo", "replay", "soundOn", "soundOff", "more", "dressup"],
                photo: ["dressup"]
            };
            GameConfig.STAGES = {
                stageTypes: ["start", "dress"],
                stages: [
                    { screen: "start", buttons: "start", next: 1, showAds: true, params: { step: 1 } },
                    { screen: "start", buttons: "main", next: 2, params: { step: 2 }, comix: { step: 1, buttons: "next" } },
                    { screen: "dress", buttons: "main", next: 3, params: { background: "dressingBack", case: 0, dolls: [{ id: 0, x: 100, y: 20, scale: 1 }, { id: 1, x: 100, y: 20, scale: 1 }], buttons: "next" } },
                    { screen: "start", buttons: "main", next: 4, params: { step: 2, dolls: [{ id: 0, x: GameConfig.GAME_WIDTH + 400, y: 80, scale: 0.95, comix: true, mirror: true }, { id: 1, x: -500, y: 60, scale: 0.95, comix: true }] }, comix: { step: 2, buttons: "next" } },
                    { screen: "start", buttons: "promo", next: 1, reset: true, params: { step: 2, dolls: [{ id: 0, x: 90, y: -20, scale: 1.4, comix: true }, { id: 1, x: 590, y: -20, scale: 1.4, comix: true, mirror: true }] }, comix: { step: 3 } },
                ]
            };
            GameConfig.VIEW_START = [
                [0, 0, 0, 0, 0, 0, 0],
                [0, 0, 0, 0, 0, 0, 0],
            ];
            GameConfig.DOLLS = [
                {
                    atlas: "doll1",
                    images: {
                        hb1: "hb/1.png", hb2: "hb/2.png", hb3: "hb/3.png", hb4: "hb/4.png", hb5: "hb/5.png", hb6: "hb/6.png", hb7: "hb/7.png",
                        body: "body.png", sad: "bodySad.png",
                        bot1: "bot/1.png", bot2: "bot/2.png", bot3: "bot/3.png", bot4: "bot/4.png", bot5: "bot/5.png", bot6: "bot/6.png", bot7: "bot/7.png", bot8: "bot/8.png", bot9: "bot/9.png",
                        sh1: "sh/1.png", sh2: "sh/2.png", sh3: "sh/3.png", sh4: "sh/4.png", sh5: "sh/5.png", sh6: "sh/6.png", sh7: "sh/7.png", sh8: "sh/8.png", sh9: "sh/9.png",
                        df1: "df/1.png", df2: "df/2.png", df3: "df/3.png", df4: "df/4.png",
                        hand: "hand.png",
                        top1: "top/1.png", top2: "top/2.png", top3: "top/3.png", top4: "top/4.png", top5: "top/5.png", top6: "top/6.png", top7: "top/7.png", top8: "top/8.png", top9: "top/9.png",
                        jw1: "jw/1.png", jw2: "jw/2.png", jw3: "jw/3.png", jw4: "jw/4.png", jw5: "jw/5.png", jw6: "jw/6.png",
                        hf1: "hf/1.png", hf2: "hf/2.png", hf3: "hf/3.png", hf4: "hf/4.png", hf5: "hf/5.png", hf6: "hf/6.png", hf7: "hf/7.png",
                    },
                    items: {
                        hair1: ["hb1", "hf1"], hair2: ["hb2", "hf2"], hair3: ["hb3", "hf3"], hair4: ["hb4", "hf4"], hair5: ["hb5", "hf5"], hair6: ["hb6", "hf6"], hair7: ["hb7", "hf7"],
                        d1: ["df1"], d2: ["df2"], d3: ["df3"], d4: ["df4"],
                        sh1: ["sh1"], sh2: ["sh2"], sh3: ["sh3"], sh4: ["sh4"], sh5: ["sh5"], sh6: ["sh6"], sh7: ["sh7"], sh8: ["sh8"], sh9: ["sh9"],
                        top1: ["top1"], top2: ["top2"], top3: ["top3"], top4: ["top4"], top5: ["top5"], top6: ["top6"], top7: ["top7"], top8: ["top8"], top9: ["top9"],
                        bot1: ["bot1", "hand"], bot2: ["bot2", "hand"], bot3: ["bot3", "hand"], bot4: ["bot4", "hand"], bot5: ["bot5", "hand"], bot6: ["bot6", "hand"], bot7: ["bot7", "hand"], bot8: ["bot8", "hand"], bot9: ["bot9", "hand"],
                        jw1: ["jw1"], jw2: ["jw2"], jw3: ["jw3"], jw4: ["jw4"], jw5: ["jw5"], jw6: ["jw6"], sad: ["sad"]
                    },
                    sets: [
                        ["hair1", "hair2", "hair3", "hair4", "hair5", "hair6", "hair7"],
                        [null, "d1", "d2", "d3", "d4"],
                        [null, "top1", "top2", "top3", "top4", "top5", "top6", "top7", "top8", "top9"],
                        [null, "bot1", "bot2", "bot3", "bot4", "bot5", "bot6", "bot7", "bot8", "bot9"],
                        [null, "sh1", "sh2", "sh3", "sh4", "sh5", "sh6", "sh7", "sh8", "sh9"],
                        [null, "jw1", "jw2", "jw3", "jw4", "jw5", "jw6"],
                        [null, "sad"]
                    ],
                    eyes: null
                },
                {
                    atlas: "doll2",
                    images: {
                        hb1: "hb/1.png", hb2: "hb/2.png", hb3: "hb/3.png", hb4: "hb/4.png", hb5: "hb/5.png", hb6: "hb/6.png", hb7: "hb/7.png",
                        body: "body.png", sad: "bodySad.png",
                        bot1: "bot/1.png", bot2: "bot/2.png", bot3: "bot/3.png", bot4: "bot/4.png", bot5: "bot/5.png", bot6: "bot/6.png", bot7: "bot/7.png", bot8: "bot/8.png", bot9: "bot/9.png",
                        sh1: "sh/1.png", sh2: "sh/2.png", sh3: "sh/3.png", sh4: "sh/4.png", sh5: "sh/5.png", sh6: "sh/6.png", sh7: "sh/7.png", sh8: "sh/8.png", sh9: "sh/9.png",
                        df1: "df/1.png", df2: "df/2.png", df3: "df/3.png", df4: "df/4.png",
                        top1: "top/1.png", top2: "top/2.png", top3: "top/3.png", top4: "top/4.png", top5: "top/5.png", top6: "top/6.png", top7: "top/7.png", top8: "top/8.png", top9: "top/9.png",
                        jw1: "jw/1.png", jw2: "jw/2.png", jw3: "jw/3.png", jw4: "jw/4.png", jw5: "jw/5.png", jw6: "jw/6.png",
                        hf1: "hf/1.png", hf2: "hf/2.png", hf3: "hf/3.png", hf4: "hf/4.png", hf5: "hf/5.png", hf6: "hf/6.png", hf7: "hf/7.png",
                    },
                    items: {
                        hair1: ["hb1", "hf1"], hair2: ["hb2", "hf2"], hair3: ["hb3", "hf3"], hair4: ["hb4", "hf4"], hair5: ["hb5", "hf5"], hair6: ["hb6", "hf6"], hair7: ["hb7", "hf7"],
                        d1: ["df1"], d2: ["df2"], d3: ["df3"], d4: ["df4"],
                        sh1: ["sh1"], sh2: ["sh2"], sh3: ["sh3"], sh4: ["sh4"], sh5: ["sh5"], sh6: ["sh6"], sh7: ["sh7"], sh8: ["sh8"], sh9: ["sh9"],
                        top1: ["top1"], top2: ["top2"], top3: ["top3"], top4: ["top4"], top5: ["top5"], top6: ["top6"], top7: ["top7"], top8: ["top8"], top9: ["top9"],
                        bot1: ["bot1"], bot2: ["bot2"], bot3: ["bot3"], bot4: ["bot4"], bot5: ["bot5"], bot6: ["bot6"], bot7: ["bot7"], bot8: ["bot8"], bot9: ["bot9"],
                        jw1: ["jw1"], jw2: ["jw2"], jw3: ["jw3"], jw4: ["jw4"], jw5: ["jw5"], jw6: ["jw6"], sad: ["sad"]
                    },
                    sets: [
                        ["hair1", "hair2", "hair3", "hair4", "hair5", "hair6", "hair7"],
                        [null, "d1", "d2", "d3", "d4"],
                        [null, "top1", "top2", "top3", "top4", "top5", "top6", "top7", "top8", "top9"],
                        [null, "bot1", "bot2", "bot3", "bot4", "bot5", "bot6", "bot7", "bot8", "bot9"],
                        [null, "sh1", "sh2", "sh3", "sh4", "sh5", "sh6", "sh7", "sh8", "sh9"],
                        [null, "jw1", "jw2", "jw3", "jw4", "jw5", "jw6"],
                        [null, "sad"]
                    ],
                    eyes: null
                }
            ];
            GameConfig.DOLLS_EYES = [];
            GameConfig.DRESSING_CONFIG = [
                {
                    atlas: "doll1",
                    pages: [
                        ["d1", "d2", "d3", "d4"],
                        ["top1", "top2", "top3", "top4", "top5", "top6", "top7", "top8", "top9"],
                        ["bot1", "bot2", "bot3", "bot4", "bot5", "bot6", "bot7", "bot8", "bot9"],
                        ["hair2", "hair3", "hair4", "hair5", "hair6", "hair7"],
                        ["jw1", "jw2", "jw3", "jw4", "jw5", "jw6"],
                        ["sh1", "sh2", "sh3", "sh4", "sh5", "sh6", "sh7", "sh8", "sh9"]
                    ],
                    veshalki: false,
                    items: {
                        d1: { image: "d1.png", x: 591, y: 329, anchor: [0.5, 0.5], scale: 1 },
                        d2: { image: "d2.png", x: 646, y: 253, anchor: [0.5, 0.5], scale: 1 },
                        d3: { image: "d3.png", x: 723, y: 263, anchor: [0.5, 0.5], scale: 1 },
                        d4: { image: "d4.png", x: 799, y: 257, anchor: [0.5, 0.5], scale: 1 },
                        top1: { image: "top1.png", x: 578, y: 204, anchor: [0.5, 0.5], scale: 1 },
                        top2: { image: "top2.png", x: 656, y: 202, anchor: [0.5, 0.5], scale: 1 },
                        top3: { image: "top3.png", x: 733, y: 197, anchor: [0.5, 0.5], scale: 1 },
                        top4: { image: "top4.png", x: 815, y: 208, anchor: [0.5, 0.5], scale: 1 },
                        top5: { image: "top5.png", x: 601, y: 364, anchor: [0.5, 0.5], scale: 1 },
                        top6: { image: "top6.png", x: 702, y: 363, anchor: [0.5, 0.5], scale: 1 },
                        top7: { image: "top7.png", x: 803, y: 342, anchor: [0.5, 0.5], scale: 1 },
                        top8: { image: "top8.png", x: 654, y: 490, anchor: [0.5, 0.5], scale: 1 },
                        top9: { image: "top9.png", x: 754, y: 490, anchor: [0.5, 0.5], scale: 1 },
                        bot1: { image: "bot1.png", x: 566, y: 266, anchor: [0.5, 0.5], scale: 1 },
                        bot2: { image: "bot2.png", x: 636, y: 262, anchor: [0.5, 0.5], scale: 1 },
                        bot3: { image: "bot3.png", x: 708, y: 258, anchor: [0.5, 0.5], scale: 1 },
                        bot4: { image: "bot4.png", x: 772, y: 192, anchor: [0.5, 0.5], scale: 1 },
                        bot5: { image: "bot5.png", x: 834, y: 190, anchor: [0.5, 0.5], scale: 1 },
                        bot6: { image: "bot6.png", x: 573, y: 460, anchor: [0.5, 0.5], scale: 1 },
                        bot7: { image: "bot7.png", x: 648, y: 461, anchor: [0.5, 0.5], scale: 1 },
                        bot8: { image: "bot8.png", x: 720, y: 463, anchor: [0.5, 0.5], scale: 1 },
                        bot9: { image: "bot9.png", x: 796, y: 463, anchor: [0.5, 0.5], scale: 1 },
                        hair2: { image: "hair1.png", x: 587, y: 211, anchor: [0.5, 0.5], scale: 1 },
                        hair3: { image: "hair2.png", x: 708, y: 208, anchor: [0.5, 0.5], scale: 1 },
                        hair4: { image: "hair3.png", x: 818, y: 201, anchor: [0.5, 0.5], scale: 1 },
                        hair5: { image: "hair4.png", x: 586, y: 405, anchor: [0.5, 0.5], scale: 1 },
                        hair6: { image: "hair5.png", x: 694, y: 415, anchor: [0.5, 0.5], scale: 1 },
                        hair7: { image: "hair6.png", x: 803, y: 415, anchor: [0.5, 0.5], scale: 1 },
                        jw1: { image: "jew1.png", x: 588, y: 243, anchor: [0.5, 0.5], scale: 1 },
                        jw2: { image: "jew2.png", x: 702, y: 245, anchor: [0.5, 0.5], scale: 1 },
                        jw3: { image: "jew3.png", x: 823, y: 248, anchor: [0.5, 0.5], scale: 1 },
                        jw4: { image: "jew4.png", x: 589, y: 437, anchor: [0.5, 0.5], scale: 1 },
                        jw5: { image: "jew5.png", x: 698, y: 447, anchor: [0.5, 0.5], scale: 1 },
                        jw6: { image: "jew6.png", x: 806, y: 454, anchor: [0.5, 0.5], scale: 1 },
                        sh1: { image: "sh1.png", x: 617, y: 199, anchor: [0.5, 0.5], scale: 1 },
                        sh2: { image: "sh2.png", x: 724, y: 200, anchor: [0.5, 0.5], scale: 1 },
                        sh3: { image: "sh3.png", x: 825, y: 200, anchor: [0.5, 0.5], scale: 1 },
                        sh4: { image: "sh4.png", x: 608, y: 337, anchor: [0.5, 0.5], scale: 1 },
                        sh5: { image: "sh5.png", x: 708, y: 337, anchor: [0.5, 0.5], scale: 1 },
                        sh6: { image: "sh6.png", x: 814, y: 339, anchor: [0.5, 0.5], scale: 1 },
                        sh7: { image: "sh7.png", x: 607, y: 456, anchor: [0.5, 0.5], scale: 1 },
                        sh8: { image: "sh8.png", x: 699, y: 456, anchor: [0.5, 0.5], scale: 1 },
                        sh9: { image: "sh9.png", x: 804, y: 463, anchor: [0.5, 0.5], scale: 1 },
                    },
                    combined: [{ set1: 1, set2: [2, 3] }],
                },
                {
                    atlas: "doll2",
                    pages: [
                        ["d1", "d2", "d3", "d4"],
                        ["top1", "top2", "top3", "top4", "top5", "top6", "top7", "top8", "top9"],
                        ["bot1", "bot2", "bot3", "bot4", "bot5", "bot6", "bot7", "bot8", "bot9"],
                        ["hair2", "hair3", "hair4", "hair5", "hair6", "hair7"],
                        ["jw1", "jw2", "jw3", "jw4", "jw5", "jw6"],
                        ["sh1", "sh2", "sh3", "sh4", "sh5", "sh6", "sh7", "sh8", "sh9"]
                    ],
                    veshalki: false,
                    items: {
                        d1: { image: "d1.png", x: 593, y: 324, anchor: [0.5, 0.5], scale: 1 },
                        d2: { image: "d2.png", x: 668, y: 321, anchor: [0.5, 0.5], scale: 1 },
                        d3: { image: "d3.png", x: 743, y: 242, anchor: [0.5, 0.5], scale: 1 },
                        d4: { image: "d4.png", x: 814, y: 237, anchor: [0.5, 0.5], scale: 1 },
                        top1: { image: "top1.png", x: 593, y: 206, anchor: [0.5, 0.5], scale: 1 },
                        top2: { image: "top2.png", x: 680, y: 212, anchor: [0.5, 0.5], scale: 1 },
                        top3: { image: "top3.png", x: 760, y: 194, anchor: [0.5, 0.5], scale: 1 },
                        top4: { image: "top4.png", x: 829, y: 184, anchor: [0.5, 0.5], scale: 1 },
                        top5: { image: "top5.png", x: 595, y: 348, anchor: [0.5, 0.5], scale: 1 },
                        top6: { image: "top6.png", x: 697, y: 347, anchor: [0.5, 0.5], scale: 1 },
                        top7: { image: "top7.png", x: 797, y: 348, anchor: [0.5, 0.5], scale: 1 },
                        top8: { image: "top8.png", x: 635, y: 494, anchor: [0.5, 0.5], scale: 1 },
                        top9: { image: "top9.png", x: 739, y: 492, anchor: [0.5, 0.5], scale: 1 },
                        bot1: { image: "bot1.png", x: 566, y: 266, anchor: [0.5, 0.5], scale: 1 },
                        bot2: { image: "bot2.png", x: 636, y: 262, anchor: [0.5, 0.5], scale: 1 },
                        bot3: { image: "bot3.png", x: 708, y: 258, anchor: [0.5, 0.5], scale: 1 },
                        bot4: { image: "bot4.png", x: 773, y: 215, anchor: [0.5, 0.5], scale: 1 },
                        bot5: { image: "bot5.png", x: 828, y: 211, anchor: [0.5, 0.5], scale: 1 },
                        bot7: { image: "bot7.png", x: 571, y: 456, anchor: [0.5, 0.5], scale: 1 },
                        bot8: { image: "bot8.png", x: 643, y: 455, anchor: [0.5, 0.5], scale: 1 },
                        bot6: { image: "bot6.png", x: 713, y: 478, anchor: [0.5, 0.5], scale: 1 },
                        bot9: { image: "bot9.png", x: 815, y: 453, anchor: [0.5, 0.5], scale: 1 },
                        hair2: { image: "hair1.png", x: 587, y: 211, anchor: [0.5, 0.5], scale: 1 },
                        hair3: { image: "hair2.png", x: 705, y: 212, anchor: [0.5, 0.5], scale: 1 },
                        hair4: { image: "hair3.png", x: 818, y: 201, anchor: [0.5, 0.5], scale: 1 },
                        hair5: { image: "hair4.png", x: 585, y: 407, anchor: [0.5, 0.5], scale: 1 },
                        hair6: { image: "hair5.png", x: 685, y: 431, anchor: [0.5, 0.5], scale: 1 },
                        hair7: { image: "hair6.png", x: 804, y: 429, anchor: [0.5, 0.5], scale: 1 },
                        jw1: { image: "jew1.png", x: 588, y: 243, anchor: [0.5, 0.5], scale: 1 },
                        jw2: { image: "jew2.png", x: 702, y: 245, anchor: [0.5, 0.5], scale: 1 },
                        jw3: { image: "jew3.png", x: 816, y: 247, anchor: [0.5, 0.5], scale: 1 },
                        jw4: { image: "jew4.png", x: 586, y: 438, anchor: [0.5, 0.5], scale: 1 },
                        jw5: { image: "jew5.png", x: 691, y: 447, anchor: [0.5, 0.5], scale: 1 },
                        jw6: { image: "jew6.png", x: 800, y: 452, anchor: [0.5, 0.5], scale: 1 },
                        sh1: { image: "sh1.png", x: 608, y: 192, anchor: [0.5, 0.5], scale: 1 },
                        sh2: { image: "sh2.png", x: 719, y: 188, anchor: [0.5, 0.5], scale: 1 },
                        sh3: { image: "sh3.png", x: 828, y: 186, anchor: [0.5, 0.5], scale: 1 },
                        sh4: { image: "sh4.png", x: 607, y: 328, anchor: [0.5, 0.5], scale: 1 },
                        sh5: { image: "sh5.png", x: 707, y: 332, anchor: [0.5, 0.5], scale: 1 },
                        sh6: { image: "sh6.png", x: 810, y: 331, anchor: [0.5, 0.5], scale: 1 },
                        sh7: { image: "sh7.png", x: 605, y: 447, anchor: [0.5, 0.5], scale: 1 },
                        sh8: { image: "sh8.png", x: 704, y: 454, anchor: [0.5, 0.5], scale: 1 },
                        sh9: { image: "sh9.png", x: 804, y: 459, anchor: [0.5, 0.5], scale: 1 },
                    },
                    combined: [{ set1: 1, set2: [2, 3] }],
                }
            ];
            GameConfig.CAROUSELS = [];
            return GameConfig;
        }());
        Client.GameConfig = GameConfig;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Globals = (function () {
            function Globals() {
            }
            Globals.SFX = true;
            Globals.DEBUG = false;
            Globals.DONT_CACHE = false;
            Globals.PRELOAD = 0;
            Globals.STAGE = 0;
            Globals.HOVER = false;
            Globals.VERSION = 0;
            Globals.DOLLS_VIEW = [];
            Globals.DOLL_DONE = [false, false];
            Globals.DRESS_DONE = [false, false, false, false, false, false];
            Globals.DRESS_SELECTED = 0;
            Globals.DOLL_SELECTED = 0;
            Globals.PLACE_ID = 0;
            Globals.BACKGROUND = 0;
            Globals.DOLLS_SCORE = [0, 0, 0];
            Globals.SCORE_VIEW = [20, 20, 15, 15, 15, 15];
            Globals.DOLLS = [];
            Globals.onScreenEvent = new Phaser.Signal();
            Globals.onItemsEvent = new Phaser.Signal();
            return Globals;
        }());
        Client.Globals = Globals;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
//# sourceMappingURL=game.js.map